
var glastCalList;
var lastKeyCode;
var gToDoCount;
var gCurrentPage;
var gTasksPerPage = 10;
var gPageLength = 200;
var gPageWidth = 195;
var gTodoListTop = 62;
var STOCK_WIDTH = 350;
var STOCK_HEIGHT = 300; 
var flipAnimation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, element:null, toolBar:null, timer:null};
var fia = {duration:0, starttime:0, element:null, timer:null};
var gSkins = [["Apple Calendar","apple"], ["Apple Note (Marker Felt)","mail"], ["Apple Note (Helvetica)","mailh"], ["Duke", "duke"], ["Hokie", "hokie"], ["Mint", "mint"],["Platinum", "plat"]];
var flipShown = false;
var gFlipped = false;
var gSetup = false;
var gWidgetDevice = 1;
var gPrintDevice = 2;
var gLastVersionCheck = 0;
var gCurrentVersion = "4.3.1";
var gCurrentBuild;
var gLastUpdate = new Date().getTime();
var gP = new prefPot();
var gNodes = new Array();
var gDetailSheet;
var gNewItemSheet;
var gNewItemDetailedSheet;
var gDeleteSheet;
var gCalListSheet;
var gClusterListSheet;
var gClusterEditSheet;
var gScheduleEditSheet;
var gSendEmailSheet;
var gPopUpCalendar;
var gPriorityPopUp;
var gTaskBalloon;
var gSelected = new Array();
var KeyListeners = new Object();
var gFuturePack = {visible:false, timer:null};


document.addEventListener("keydown", keyDowned, false);

function setup()
{   

    setUpFront();
    
    if (!window.widget) {
        document.getElementById('splash').innerHTML = "Window.widget failed";
        return false;
    }
    
    setUpPrefs();
    
    document.getElementById('splash').innerHTML = "Error: DoBeDo plugin failure.<br/><br/>This version of DoBeDo requires OSX Leopard (10.5).";
    
    if (!pluginOK()){
        document.getElementById('splash').innerHTML = "Error: DoBeDo plugin failure.";
        return false;
    }
    
    document.getElementById('splash').innerHTML = "";
    
    if (!leopardOSX()){
        document.getElementById('splash').innerHTML = "<br/><br/>This version of DoBeDo requires OSX Leopard(10.5) or greater.";
        return false;    
    }
    
    if (!dataDirectory()){
        document.getElementById('splash').innerHTML = "Error: Could not open data directory.";
        return false;
    }
    
    if (!initAllNodes()){
        document.getElementById('splash').innerHTML = "Error: Failed to load calendars and groups.";
        return false;    
    }
    
    setUpDialogs();
    
    relistCalendars();
    
    setUpBack();
    
    calChanged();
    
    document.getElementById('splash').style.visibility = "hidden";
    document.getElementById('front').style.visibility = "visible";
    
    resizeWidget(gP.gp("widgetWidth"), gP.gp("widgetHeight"));
    resizeCompleted();
    
    gSetup = true;
    
	return gSetup;
}

function setUpPrefs()
{
    gP.registerPref("currentNodeKey", "ALLCAL-NODEKEY");
    gP.registerPref("sort", 2);
    gP.registerPref("completedDays", 2);
    gP.registerPref("futureDays", 180);
    gP.registerPref("printDevice", "PDF Preview");
    gP.registerPref("showPriorityAndDueDate", true);
    gP.registerPref("showUrlJump", false);
    gP.registerPref("showToolTips", true);
    gP.registerPref("nlp", true);
    gP.registerPref("skinStyle", gSkins[2][1]);
    gP.registerPref("newSheetDetail", 0);
    gP.registerPref("widgetWidth", STOCK_WIDTH);
    gP.registerPref("widgetHeight", STOCK_HEIGHT);
    gP.registerPref("phoneHomeVersionCheck", true);

    widget.onshow = onshow; widget.onhide = onhide; widget.onremove = onremove;  
}


function setUpFront()
{
    visibleToDoBox(true);
    var df = document.getElementById('front');
    df.addEventListener("mousemove", mousemove, true);
    df.addEventListener("mouseout", mouseexit, true);  
	
	visibleToDoBox(false);
}

function setUpBack()
{

    var doneButton = document.getElementById('doneButton');  createGenericButton(doneButton, "Done", hideBack);
    document.getElementById('calendarsLabel').innerHTML = "Manage:";
    document.getElementById('sortselectLabel').innerHTML = "Sort:";
    document.getElementById('completedselectLabel').innerHTML = "Completed:";
    document.getElementById('futureselectLabel').innerHTML = "Future:";
    document.getElementById('printerLabel').innerHTML = "Printer:";
    document.getElementById('baseColorLabel').innerHTML = "Style:";
    document.getElementById('newSheetDetailLabel').innerHTML = "New Dialog:";
    document.getElementById('showPriorityAndDueDateLabel').innerHTML = "Show Due & Priority";
    document.getElementById('showUrlJumpLabel').innerHTML = "Show URL Links";
    document.getElementById('showToolTipsLabel').innerHTML = "Show Tooltips";
    document.getElementById('useNLPLabel').innerHTML = "Natural Language";;
    document.getElementById('versionCheckLabel').innerHTML = "Check for Updates"
    document.getElementById('betaNote').innerHTML = "<a href=\"#\" onClick='widget.openURL(\"http://www.bluehenley.com/products/dobedo/index.php?bv4=" + gCurrentBuild + "&ref=widget\")'>DoBeDo v" + gCurrentVersion + "</a>";
    document.getElementById('copyRight').innerHTML = "&#169;2009 <span class=\"bh\">Blue</span>Henley";

    gCalListSheet = new calListSheet(); gCalListSheet.init("calmanage"); gCalListSheet.setRect(25,50,300,270);
    gClusterEditSheet = new clusterEditSheet(); gClusterEditSheet.init("clusteredit"); gClusterEditSheet.setRect(25,50,300,270);
    gScheduleEditSheet = new scheduleEditSheet(); gScheduleEditSheet.init("clusteredit"); gScheduleEditSheet.setRect(25,50,300,270);
    
    var pc = document.getElementById('calendarsselect');
    addOptionToSelect("Calendars & Lists", "editcals", false, pc);
    addOptionToSelect("Groups", "editgroups", false, pc);
    addOptionToSelect("Schedules", "schedules", false, pc);
    addOptionToSelect("Favorites", "clusters", false, pc);
    addOptionToSelect("-------", "", true, pc);
    
    relistSortOptions();
    relistCompletedOptions();
    relistFutureOptions();
    relistPrintOptions();
        printerChanged();
    relistBaseColorOptions();
        baseColorChanged();
    relistNewSheetDetailOptions();
        newSheetDetailChanged();
        
    document.getElementById('showPriorityAndDueDateCheckBox').checked = gP.gp("showPriorityAndDueDate");
    document.getElementById('useNLPCheckBox').checked = gP.gp("nlp");
    document.getElementById('showUrlJumpCheckBox').checked = gP.gp("showUrlJump");
    document.getElementById('showToolTipsCheckBox').checked = gP.gp("showToolTips");
    document.getElementById('versionCheckCheckBox').checked = gP.gp("phoneHomeVersionCheck");
}

function setUpDialogs(){
    
    gDetailSheet = new itemDetailSheet();
        gDetailSheet.init("itemDetail");
    gNewItemSheet = new newItemSheet();
        gNewItemSheet.init("newItem");
    gNewItemDetailedSheet = new itemDetailSheet();
        gNewItemDetailedSheet.init("newItemDetailed");
    gClusterListSheet = new clusterListSheet();
        gClusterListSheet.init("clusterList");
    gDeleteSheet = new deleteItemSheet();
        gDeleteSheet.init("deleteItem");
    gPopUpCalendar = new calendarSheet();
        gPopUpCalendar.init("popupCalendarToDoList", createMethodReference(this, "popupCalendarToDoListDateSelected"));
    gPriorityPopUp = new priorityPopUpSheet();
        gPriorityPopUp.init("priorityPopUp", createMethodReference(this, "priorityPopUpItemSelected"));
    gSendEmailSheet = new emailSendSheet();
        gSendEmailSheet.init("emailSend");
    gTaskBalloon = new taskBalloon();
        gTaskBalloon.init();
        
}

function disableAllStyleSheets(){
    var lnks = document.getElementsByTagName('link');
    for (var i = 0; i < lnks.length; i++){
        lnks[i].disabled = true;    
    }    
}

function setStyle(pv){
    disableAllStyleSheets();
    document.getElementById(pv).disabled = false;
}

function currentCal(){
    for(var i = 0; i < gNodes.length; i++){
        if (gNodes[i].getNodeKey() == gP.gp("currentNodeKey")) return gNodes[i];
    }
    return null;
}

function getCurrentSelectedNodeTitle(){
    return currentCal().getTitle();
}

function dataDirectory(){
    return dobedoPlug.setPaths("nil");
}

function initAllNodes(){
    return dobedoPlug.initAllNodes();
}

function resetManageSelection(){
    document.getElementById('calendarsselect').selectedIndex = 4;
}

function relistSortOptions()
{   
    var sopts = ["Alphabetically", "Due Date", "Priority", "Calendar or List"];
    
    for(var i = 0; i < sopts.length; i++)
        addOptionToSelect(sopts[i], i + 1, (i + 1 == gP.gp("sort")) ? true : false, document.getElementById('sortselect'));
}

function relistCompletedOptions(){
    var sopts = [["Hide Completed",0], ["1 Day",1], ["2 Days", 2], ["3 Days",3], ["7 Days",7], ["1 Month",30], ["6 Months", 180]];
    
    for(var i = 0; i < sopts.length; i++)
        addOptionToSelect(sopts[i][0], sopts[i][1], (sopts[i][1] == gP.gp("completedDays")) ? true : false, document.getElementById('completedselect')); 
}

function relistFutureOptions(){
    var sopts = [["None",1000000], ["Today",999999], ["1 Day",1], ["2 Days", 2], ["3 Days",3], ["5 Days",5], ["7 Days",7], ["2 Weeks", 14], ["3 Weeks", 21], ["1 Month",30], ["2 Months",60], ["3 Months",90], ["6 Months", 180], ["1 Year", 365],["3 Years", 1095], ["5 Years", 1825]];
    
    for(var i = 0; i < sopts.length; i++)
        addOptionToSelect(sopts[i][0], sopts[i][1], (sopts[i][1] == gP.gp("futureDays")) ? true : false, document.getElementById('futureselect'));  
}

function relistPrintOptions(){
    var printerList = dobedoPlug.printerListing();
    var cs = document.getElementById('printerSelect'); cs.innerHTML = "";
    
    addOptionToSelect("PDF Preview", "PDF Preview", true, cs);
    
    for(var i = 0; i < getat(printerList, "count"); i++){
        var prnt = getat(getat(printerList, "printer" + i),"name");
        addOptionToSelect(prnt, prnt, (prnt == gP.gp("printDevice")) ? true : false, cs);      
    }
}

function relistNewSheetDetailOptions(){
    var sopts = [["Basic",0], ["Detailed", 1]];
    for(var i = 0; i < sopts.length; i++)
        addOptionToSelect(sopts[i][0], sopts[i][1], (sopts[i][1] == gP.gp("newSheetDetail")) ? true : false, document.getElementById('newSheetDetailSelect'));  
}

function relistBaseColorOptions()
{
    for(var i = 0; i < gSkins.length; i++)
        addOptionToSelect(gSkins[i][0], gSkins[i][1], (gSkins[i][1] == gP.gp("skinStyle")) ? true : false, document.getElementById('baseColorSelect'));
}

function relistCalendars()
{
    var cs = document.getElementById('titleCalSelect');
    var pc = document.getElementById('calendarsselect');
    var op3 = document.createElement("option");op3.appendChild(document.createTextNode("Empty"));op3.value = "Empty";op3.selected = true;
    var allCalSource = new Array();
    gNodes.length = 0;
    
    var cals = dobedoPlug.icalList();
    glastCalList = cals;
    var cnt = getat(cals, "count");
    cs.innerHTML = "";
    
    ///calendars first
    for (var i = 0; i < cnt; i++){
        var nd = new calNode();
        nd.initWithTaggedString(getat(cals, "cal" + i));
        if (!nd.isGroup()) allCalSource.push(nd.getSourceKey());
        gNodes.push(nd);
    }
    
    
    ///sort calendars
    gNodes.sort(function(a,b){
        var ax = a.getTitle().toUpperCase(); var bx = b.getTitle().toUpperCase();
        return ((ax > bx) ? 1 : (ax < bx) ? -1 : 0);
    }) 
    
    ///add calendars to the option lists
    for(var i = 0; i < gNodes.length; i++){
        if (gNodes[i].isGroup() || !gNodes[i].isVisible()) continue;
        addOptionToSelect(gNodes[i].getTitle(), gNodes[i].getSourceKey(), (gP.gp("currentNodeKey") == gNodes[i].getNodeKey()) ? true : false, cs).nd = gNodes[i];
    }
    ///add group divider
        addOptionToSelect("----Groups----", "", false, cs);
        
    ///add groups to the option list
    for(var i = 0; i < gNodes.length; i++){
        if (!gNodes[i].isGroup() || !gNodes[i].isVisible()) continue;
        addOptionToSelect(gNodes[i].getTitle(), gNodes[i].getSourceKey(), (gP.gp("currentNodeKey") == gNodes[i].getNodeKey()) ? true : false, cs).nd = gNodes[i];
    }    
    
    ///add the ALL option               
        var nd = new calNode();
        nd.initWithTaggedString("<allcal><nodekey>ALLCAL-NODEKEY</nodekey><sourcekey>" + allCalSource.join() + "</sourcekey><title>All</title><themecolor>#A6A6A6</themecolor><selected>1</selected><type>CALNamedGroupNode</type><access>rw</access></allcal>");
        nd.setAll(true);
        nd.setVisible(true);
        gNodes.push(nd);
        addOptionToSelect("All", allCalSource.join(), (gP.gp("currentNodeKey") == gNodes[i].getNodeKey()) ? true : false, cs).nd = gNodes[i];
}


function thereAreNewCalendars(){
    var cals = dobedoPlug.icalList();
    if (cals == glastCalList){
        return false;
    }else{
        glastCalList = cals;
        return true;
    }
}

function fillSelectWithCalendars(rSel, calToSelect)
{
    rSel.innerHTML = "";
    for(var i = 0; i < gNodes.length; i++){
        if (gNodes[i].isGroup() || !gNodes[i].isVisible()) continue;
        addOptionToSelect(gNodes[i].getTitle(), gNodes[i].getSourceKey(), (calToSelect == gNodes[i].getSourceKey()) ? true : false, rSel);
    }
}

function fillSelectWithAGroupsCalendars(rSel, rGroup, calToSelect)
{
    rSel.innerHTML = "";
    var sa = rGroup.getSourceKey().split(",");
    
    for(var i = 0; i < sa.length; i++){
        var n = calNodeFromSourceKey(sa[i]);
        if (n) addOptionToSelect(n.getTitle(), n.getSourceKey(), (calToSelect == n.getSourceKey()) ? true : false, rSel);
    }
}

function calNodeFromSourceKey(sk){
    if (!sk) return null;
    for(var i = 0; i < gNodes.length; i++){
        if (gNodes[i].getSourceKey() == sk && !gNodes[i].isGroup()) return gNodes[i]; 
    }
    return null;  
}

function nodeFromNodeID(nid)
{
    if (!nid) return null;
    for(var i = 0; i < gNodes.length; i++){
        if (gNodes[i].getNodeKey() == nid) return gNodes[i]; 
    }
    return null;
}

function calNodeFromName(cname)
{
    if (!cname) return null;
    for(var i = 0; i < gNodes.length; i++){
        if (gNodes[i].getTitle().toUpperCase() == cname.toUpperCase()) return gNodes[i]; 
    }
    return null;
}


function stepPriorityValue(cpv){
    var rv;
    switch(parseInt(cpv)){
        case 0:
            rv =  "9";
            break;
        case 3:
            rv = "5";
            break;
        case 2:
            rv = "1"
            break;
        case 1:
            rv = "0";
            break;
        default:
            rv = "0";
            break;
    }
    return rv;
}


function priorityToDoListMouseDown(calId, uid, currentPriorityIndex)
{

    if (currentCal().isReadOnly()) return;
    
    if (event.metaKey){
        event.preventDefault();
        dobedoPlug.setPriority(calId, uid, stepPriorityValue(currentPriorityIndex));
        updateToDoData();
        turnPageToItem(uid);
        return;
    }
    
    ///////////
    var pos = absolutePosition(event.target);
    gPriorityPopUp.uid = uid;
    gPriorityPopUp.calID = calId;
    gPriorityPopUp.setRect(pos.x - 90, pos.y - 18, 90, 60);
    gPriorityPopUp.showSheet();
}


function priorityPopUpItemSelected(xselected)
{
    dobedoPlug.setPriority(gPriorityPopUp.calID, gPriorityPopUp.uid, gPriorityPopUp._priorityValue);
    updateToDoData();
    turnPageToItem(gPriorityPopUp.uid); 
}

function dueDateClicked(calID, uid)
{
    if (currentCal().isReadOnly()) return;
    
    gPopUpCalendar.calID = calID;
    gPopUpCalendar.uid = uid;
    
    var ap = absolutePosition(event.target);
    var calSize = {x:150,y:112};
    if ((ap.y + calSize.y + 15) > window.innerHeight) ap.y = ap.y - calSize.y - 15;
    
    gPopUpCalendar.setRect(ap.x - calSize.x + 38, ap.y + 15,calSize.x,calSize.y);
    gPopUpCalendar.showSheet();
}

function popupCalendarToDoListDateSelected(sdate)
{
    dobedoPlug.setDueDate(gPopUpCalendar.uid, sdate.getMonth() + 1 + "/" + sdate.getDate() + "/" + sdate.getFullYear());
    updateToDoData();
    turnPageToItem(gPopUpCalendar.uid);
}

function dueDateAllPopUpSelectChanged(elmt, calId, uid)
{
    dobedoPlug.setDueInDays(calId, uid, elmt.value);
    updateToDoData(); 
    turnPageToItem(uid);  
}

function calChanged(cnudge)
{
    var cs = document.getElementById('titleCalSelect');
    
    if (cs.options[cs.selectedIndex].value == "") return;
    gP.setPref("currentNodeKey",cs.options[cs.selectedIndex].nd.getNodeKey());
    
    document.getElementById('currentCal').innerHTML = "<span>" + cs.options[cs.selectedIndex].text + "</span>";
 
    document.getElementById('titleIcon').style.visibility = (currentCal().isSubscription()) ? "visible" : "hidden";

    if (cnudge) dobedoPlug.nudge(currentCal().getNodeKey());
    
    updateToDoData();
    
    turnToPage(1);
}

function titleCalChanged()
{
    calChanged(true);
}

function calendarListChanged()
{
    var pc = document.getElementById('calendarsselect');
    if (pc.options[pc.selectedIndex].value == "editcals"){
        gCalListSheet.showSheet("cal");
    }else if (pc.options[pc.selectedIndex].value == "editgroups"){
        gCalListSheet.showSheet("group");
    }else if (pc.options[pc.selectedIndex].value == "clusters"){
        gClusterEditSheet.showSheet();
    }else if (pc.options[pc.selectedIndex].value == "schedules"){
        gScheduleEditSheet.showSheet();
    }
}

function sortChanged()
{
    var ss = document.getElementById('sortselect');
    gP.setPref("sort", ss.options[ss.selectedIndex].value);
    updateToDoData();
}

function completedChanged()
{
    var ss = document.getElementById('completedselect');
    gP.setPref("completedDays", ss.options[ss.selectedIndex].value);
    updateToDoData();
}

function futureChanged()
{
    backToTheFuture();
    var ss = document.getElementById('futureselect');
    gP.setPref("futureDays", ss.options[ss.selectedIndex].value);
    updateToDoData();
}

function printerChanged()
{
    var ss = document.getElementById('printerSelect');
    gP.setPref("printDevice", ss.options[ss.selectedIndex].value);
    dobedoPlug.setPrinterName(ss.options[ss.selectedIndex].value);
}

function baseColorChanged()
{
    var ss = document.getElementById('baseColorSelect');
    gP.setPref("skinStyle", ss.options[ss.selectedIndex].value);
    setStyle(gP.getPref("skinStyle"));
}

function newSheetDetailChanged()
{
    var ss = document.getElementById('newSheetDetailSelect');
    gP.setPref("newSheetDetail", ss.options[ss.selectedIndex].value);
}

function useNLPChanged()
{
    gP.setPref("nlp", document.getElementById('useNLPCheckBox').checked);
}

function useNLPLabelClicked()
{
    document.getElementById('useNLPCheckBox').checked = !document.getElementById('useNLPCheckBox').checked;
    useNLPChanged();
}

function showUrlJumpChanged()
{
    gP.setPref("showUrlJump", document.getElementById('showUrlJumpCheckBox').checked);
    updateToDoData();
}

function showUrlJumpLabelClicked()
{
    document.getElementById('showUrlJumpCheckBox').checked = !document.getElementById('showUrlJumpCheckBox').checked;
    showUrlJumpChanged();
}

function showToolTipsChanged()
{
    gP.setPref("showToolTips", document.getElementById('showToolTipsCheckBox').checked);
}

function showToolTipsLabelClicked()
{
    document.getElementById('showToolTipsCheckBox').checked = !document.getElementById('showToolTipsCheckBox').checked;
    showToolTipsChanged();
}

function versionCheckChanged()
{
    gP.setPref("phoneHomeVersionCheck", document.getElementById('versionCheckCheckBox').checked);
    if (gP.getPref("phoneHomeVersionCheck")) setTimeout('checkCurrentVersion()', 500);
}

function versionCheckClicked()
{
    document.getElementById('versionCheckCheckBox').checked = !document.getElementById('versionCheckCheckBox').checked;
    versionCheckChanged();   
}

function showPriorityAndDueDateChanged()
{
    gP.setPref("showPriorityAndDueDate", document.getElementById('showPriorityAndDueDateCheckBox').checked);
    updateToDoData();
}

function showPriorityAndDueDateLabelClicked(event)
{
    document.getElementById('showPriorityAndDueDateCheckBox').checked = !document.getElementById('showPriorityAndDueDateCheckBox').checked;
    showPriorityAndDueDateChanged();
}

function checkBoxClickedDelta(uid, checked)
{
    if (currentCal().isReadOnly()) return;
    dobedoPlug.markToDoCompleted(uid, !checked);
    updateToDoData();
    if (checked)turnPageToItem(uid);
}

function translatePriority(intPriorityLevel)
{
    if (intPriorityLevel < 1) return "None";
    if (intPriorityLevel < 3) return "High";
    if (intPriorityLevel < 7) return "Medium";
    return "Low";
}

function todoItemClicked(pt)
{
    if (currentCal().isReadOnly()) return;

    if (event.shiftKey){
    
        shiftSelection(pt);
        
    }else if (event.ctrlKey || event.metaKey){
    
        if (isSelected(pt)){
            deSelectItem(pt);
        }else{
            selectItem(pt);
        }
        
    }else{
  
        deSelectAll();
        selectItem(pt);
        
    }
    
    event.stopPropagation();
    
    gTaskBalloon.hide();
}

function todoItemDblClicked(pt)
{   
    if (currentCal().isReadOnly()) return;

    event.stopPropagation();
    
    deSelectAll();
    
    gTaskBalloon.disable();
    
    if (gDetailSheet.loadSheet(pt)) gDetailSheet.showSheet();  
        
}

function urlClicked(pt)
{
    widget.openURL(pt);
    
    event.stopPropagation();
}


function todoMouseOver(pt)
{
 
    if (!gP.gp("showToolTips")) return;
    
    gTaskBalloon.updateBalloonData(pt, event);
    
    gTaskBalloon.activate(pt, event);
    
}

function todolistMouseOut()
{
    gTaskBalloon.hide();
}

function newToDoBlur()
{
    visibleToDoBox(false);
}

function procrastinateClicked()
{
    if (gSelected.length == 0) return;
    dobedoPlug.procrastinate(gSelected.join(","));
    updateToDoData();
}

function todoListCLicked(event)
{
    deSelectAll();
    event.stopPropagation();
}

function dblClick(event)
{
    if (currentCal().isReadOnly()) return;
    
    gTaskBalloon.hide();
    
    (currentCal().isGroup()) ? plusButtonClicked() : visibleToDoBox(true);
}

function visibleToDoBox(vshow)
{
    var nrd = document.getElementById('newToDoDiv');
    
    if (vshow){
        var maxX = window.innerWidth - 195;
        nrd.style.left = event.clientX > maxX ? maxX : event.clientX - 10; nrd.style.top = event.clientY - 15;
        document.getElementById('newToDoText').focus();
        nrd.addEventListener("blur", newToDoBlur, true);
		addKeyListener("quickitemKey", createMethodReference(this, "quickKeyDownHandler"));
    }else{
		removeKeyListener("quickitemKey", createMethodReference(this, "quickKeyDownHandler"));
        document.getElementById('newToDoText').value ="";  
        nrd.style.left = -200; nrd.style.top = -200;
        nrd.removeEventListener("blur", newToDoBlur, true); 
    }      
}

function quickKeyDownHandler(){
	event.hijacked = true;	
}


function addNewToDo()
{
    var cs = currentCal().getSourceKey();
    var xd = document.getElementById('newToDoText');
    if (xd.value == "") return false;
    var tx = dobedoPlug.addNewToDo(cs, xd.value, gP.gp("nlp"));
    updateToDoData();
    visibleToDoBox(false);
    turnPageToItem(tx);
}

function addNewToDoHeadless(cuid, taskTitle)
{
    var tx = dobedoPlug.addNewToDo(cuid, taskTitle, true);
    updateToDoData();
    turnPageToItem(tx);
}


function selectItem(uid)
{

    if (gSelected.contains(uid)) return;
    
    addClass(uid, "iSelected");
                
    gSelected.push(uid);

}

function deSelectItem(uid)
{

    if (!gSelected.contains(uid)) return;
    
    removeClass(uid, "iSelected");
    
    gSelected.remove(uid);

}

function selectAll()
{
    gSelected.clear();
        
    var tdx = document.getElementById('todolist');

    for (var itemi=0;itemi<tdx.childNodes.length;itemi++) {
    
        var ix = tdx.childNodes[itemi];
        
        if (ix.className && ix.className.indexOf("tdln") > -1) selectItem(ix.childNodes[1].id);      
        
    } 
}


function deSelectAll()
{
    
    var tdx = document.getElementById('todolist');
    
    for (var itemi=0;itemi<tdx.childNodes.length;itemi++) {
    
        var ix = tdx.childNodes[itemi];
        
        if (ix.className && ix.className.indexOf("tdln") > -1) deSelectItem(ix.childNodes[1].id);
            
    }

}


function isSelected(uid)
{
    
    return gSelected.contains(uid);
    
}

function shiftSelection(uid)
{
    
    var rnga = -1;
    
    var rngb = -1;
    
    var rngx = -1;
    
    var tdx = document.getElementById('todolist');
    
    
    for (var itemi=0;itemi<tdx.childNodes.length;itemi++) {
    
        var ix = tdx.childNodes[itemi];
        
        if (ix.className && ix.className.indexOf("tdln") > -1){
        
            if (uid == ix.childNodes[1].id) rngx = itemi;
            
            if (!isSelected(ix.childNodes[1].id)) continue;
            
            if (rnga == -1) rnga = itemi;
            
            if (itemi > rngb) rngb = itemi;
            
        }
    }
    
    
    if (rngx < rnga){
        
        rnga = rngx;
        
    }else if (rngx > rngb){
    
        rngb = rngx;
        
    }

    for (var itemi=0;itemi<tdx.childNodes.length;itemi++) {
    
        var ix = tdx.childNodes[itemi];
        
        if (ix.className && ix.className.indexOf("tdln") > -1) {
        
            if (itemi >= rnga && itemi <= rngb){
                
                selectItem(ix.childNodes[1].id);
                
            }else{
            
                deSelectItem(ix.childNodes[1].id);
            
            }
        
        }

    } 

}



function updateToDoData()
{

    var d = dobedoPlug.todoListHTML(currentCal().getSourceKey() , gP.gp("sort"), gP.gp("completedDays"), gFuturePack.visible ? 1000000 : gP.gp("futureDays"), gP.gp("showPriorityAndDueDate"), gWidgetDevice, "<url>" + gP.gp("showUrlJump") + "</url>");
    
    if (d == undefined){
        document.getElementById('todolist').innerHTML = "";
    }else{ 
        document.getElementById('todolist').innerHTML = d;
    }

    gToDoCount = dobedoPlug.getToDoCount(currentCal().getSourceKey(), gP.gp("completedDays"), gFuturePack.visible ? 1000000 : gP.gp("futureDays"));
    document.getElementById('todolist').style.height = (gToDoCount > 0) ? (totalPages() * gPageLength) : gPageLength;
  
    turnToPage(gCurrentPage);
    gLastUpdate = new Date().getTime();
    
    deSelectAll();
    
}

function turnToPage(x)
{
    if (x == null || x > totalPages()) x = 1;
    if (x < 1) {x = totalPages(); turnToPage(x);}
    var td = document.getElementById('todolist');
    var tdx = (-(x - 1) * gPageLength) + gTodoListTop;
    var cdx = (x - 1) * gPageLength;
    td.style.clip = "rect(" + cdx +"px auto " +  (cdx + gPageLength)  + "px auto)";
    td.style.top = tdx;
    gCurrentPage = x;
    if (totalPages() > 1){
        document.getElementById('curpage').innerHTML = gCurrentPage + " of " + totalPages();
    }else{
        document.getElementById('curpage').innerHTML = "";
    }
    ////
    (gCurrentPage >= totalPages()) ? document.getElementById('rarrow').style.display = "none" : document.getElementById('rarrow').style.display = "block";
    (gCurrentPage <=  1) ? document.getElementById('larrow').style.display = "none" : document.getElementById('larrow').style.display = "block";
    return;  
}


function turnPageToItem(uid)
{
    var tdx = document.getElementById('todolist');
    var ic = 0;
    for (var itemi=0;itemi<tdx.childNodes.length;itemi++) {
        var ix = tdx.childNodes[itemi];
        if (ix.className && ix.className.indexOf("tdln") > -1){
            if (ix.childNodes[1].id == uid){
                turnToPage(parseInt(ic/gTasksPerPage) + 1);
                highLightItem(uid);
                return;
            }   
            ic++;         
        }
    }
}

function highLightItem(uid)
{
    var x = document.getElementById(uid);
    x.style.opacity = 1.0;
    clearInterval (fia.timer);
	fia.timer = null;  
    fia.duration = 300;
    fia.starttime = (new Date).getTime();
    fia.element = x;
    fia.timer = setInterval ("blinker()", 36);
}

function blinker(){
	var time = (new Date).getTime();
	
	if (fia.starttime + fia.duration > time){
	   rv = Math.cos((time - fia.starttime) * Math.PI/270);
	   fia.element.style.opacity = 0.75 + (0.25 * rv);
	}else{
	   clearInterval (fia.timer);
	   fia.timer = null;
	   fia.element.style.opacity = 1.0;
    }
}

function totalPages()
{
    if (gToDoCount % gTasksPerPage){
        return parseInt(gToDoCount/gTasksPerPage) + 1;
    }else{
        return parseInt(gToDoCount/gTasksPerPage);
    }
}

function lArrowClick(event)
{
    turnToPage(gCurrentPage - 1);
}

function rArrowClick(event)
{
    turnToPage(gCurrentPage + 1);
}

function newToDoKeyDown(event)
{
    
    switch(event.charCode) {
		case 3:
		  ///enter
		  if (lastKeyCode == 3) return; 
		  addNewToDo(); 
		case 13:
		  ///return
		  if (lastKeyCode == 3) return;
		  addNewToDo();
		case 27:
		  ///escape
		  visibleToDoBox(false);	
		case 63272:
		  ///delete
		  visibleToDoBox(false);	
		default:		
	}
    lastKeyCode = event.charCode;
}

function onshow(){
    if (!gSetup) return;
    if (new Date().getTime() - gLastUpdate > 7200000) updateToDoData();
}

function onhide(){
}

function onremove(){
    dobedoPlug.laterAlligator();
    gP.removePrefs();
}


function showBack() 
{ 
    relistCalendars();
    resetManageSelection();
    var front = document.getElementById("front"); 
    var back = document.getElementById("back"); 
    
    if (window.widget) widget.prepareForTransition("ToBack"); 
    front.style.display="none"; 
    back.style.display="block";
    
    if (gP.getPref("widgetHeight") < 350) resizeWidget(350, 350);
    
    if (window.widget) setTimeout ('widget.performTransition();', 0); 
    gFlipped = true;
    
    if ((new Date().getTime() - gLastVersionCheck) > 172800000 && gP.getPref("phoneHomeVersionCheck")){
        setTimeout('checkCurrentVersion()', 500);
    } 
} 

function checkCurrentVersion()
{
    document.getElementById('versionAlert').innerHTML = "";
    dobedoPlug.versionCheck("http://www.bluehenley.com/products/dobedo/cv.php?bv4=" + gCurrentBuild + "&skin=" + gP.gp("skinStyle"), "versionResponse");
    gLastVersionCheck = new Date().getTime();
}

function versionResponse(cv)
{   
    if (!gFlipped) return;
    if (getat(cv, "error") == "nil" && parseInt(getat(cv, "currentbuild")) > parseInt(gCurrentBuild)) document.getElementById('versionAlert').innerHTML = "<a href=\"#\" onClick='widget.openURL(\"" + getat(cv, "url") + "\")'>New version available!</a>";
}

function hideBack() 
{ 
    var front = document.getElementById("front"); 
    var back = document.getElementById("back"); 
    
    if (gP.getPref("widgetHeight") < 350) resizeWidget(gP.getPref("widgetWidth"), gP.getPref("widgetHeight"));

    if (window.widget) widget.prepareForTransition("ToFront"); 
    back.style.display="none"; front.style.display="block"; 
    if (window.widget) setTimeout ('widget.performTransition();', 0); 
    gFlipped = false;
} 


function plusButtonClicked()
{
    if (currentCal().isReadOnly()) return;
    
    if (gP.gp("newSheetDetail") == 0){
        gNewItemSheet.showSheet();
    }else{
        gNewItemDetailedSheet.loadSheetForNew();
        gNewItemDetailedSheet.showSheet();
    }
}

function clusterButtonClicked()
{
    gClusterListSheet.showSheet();
}

function deleteToolClicked()
{
    if (gSelected.length == 0) return;
    
    gDeleteSheet.setItem("", gSelected.join(","), true);
    
    gDeleteSheet.showSheet();
}

function addKeyListener(kn, kv){
    KeyListeners[kn] = kv;
}

function removeKeyListener(kn){
    delete KeyListeners[kn];
}

function keyDowned(event)
{
    for (var i in KeyListeners){
        KeyListeners[i]();
    }
    if (event.hijacked) return;
    /////
    
    if (gFlipped) return;
    if ((event.metaKey && event.charCode == 107) || (event.metaKey && event.charCode == 110)){
            plusButtonClicked();
            event.preventDefault();
    }
   
    if (event.charCode == 63232 || event.charCode == 63234){lArrowClick(null);event.preventDefault();}
    if (event.charCode == 63233 || event.charCode == 63235){rArrowClick(null);event.preventDefault();}
    if (event.metaKey && event.charCode == 112) {print();event.preventDefault();}
    if (event.metaKey && event.charCode == 101) {email();event.preventDefault();}
    if (event.metaKey && event.charCode == 102) {toggleFuture();event.preventDefault();}
    if (event.metaKey && event.charCode == 100) {showPriorityAndDueDateLabelClicked(event);event.preventDefault();}
    if (event.metaKey && event.charCode == 97) {selectAll();event.preventDefault();}
    if (event.charCode == 63272) {deleteToolClicked();event.preventDefault();}
}

function toggleFuture(){
    gFuturePack.visible = !gFuturePack.visible;
    updateToDoData();
    
    if (gFuturePack.visible){
        document.getElementById('alert').style.display = 'block';
        gFuturePack.timer = setTimeout(backToTheFuture, 30000);
    }else{
        document.getElementById('alert').style.display = 'none';
        clearTimeout(gFuturePack.timer);
    }
    
}

function backToTheFuture(){
    if (gFuturePack.visible){
        document.getElementById('alert').style.display = 'none';
        gFuturePack.visible = !gFuturePack.visible;
        updateToDoData();
    }
}

function email(){
    gSendEmailSheet.showSheet();
}

function print(){
    setTimeout (showPrintIcon(false, gP.getPref("printDevice")), 10);
    setTimeout (printJob, 50);
    setTimeout (hidePrintIcon, (gP.getPref("printDevice") == "PDF Preview") ? 3000 : 7000);
}

function printJob(){
    dobedoPlug.todoListHTML(currentCal().getSourceKey() , gP.gp("sort"), 0, gP.gp("futureDays"), gP.gp("showPriorityAndDueDate"), gPrintDevice, "<recordfilter>" + gSelected.join(",") + "</recordfilter>");
}

function showPrintIcon(showError, pText){
    document.getElementById('printer').style.display = 'block'; 
    document.getElementById('printer').style.left = Math.ceil(window.innerWidth/2) - 72 + "px";
    document.getElementById('printerText').style.display = 'block'; 
    document.getElementById('printerText').innerHTML = pText; 
    showError ?  document.getElementById('printerError').style.display = 'block' :  document.getElementById('printerError').style.display = 'none';
}

function hidePrintIcon(){
    document.getElementById('printer').style.display = 'none'; 
    document.getElementById('printerText').style.display = 'none';
    document.getElementById('printerError').style.display = 'none'; 
}

function resizeWidget(x,y){
    if (x < STOCK_WIDTH) x = STOCK_WIDTH;
    if (y < STOCK_HEIGHT) y = STOCK_HEIGHT;
    var xd = x - STOCK_WIDTH;
    var yd = y - STOCK_HEIGHT;
    
        gPageWidth = xd + 300;
        document.getElementById('skinTopMiddle').style.width = xd + 270;
        document.getElementById('skinCenterMiddle').style.width = xd + 270;
        document.getElementById('skinBottomMiddle').style.width = xd + 270;
        document.getElementById('todolist').style.width = gPageWidth + "px"; 
        /////
        gPageLength = (parseInt(yd/20) * 20) + 200;
        gTasksPerPage = gPageLength / 20;
        document.getElementById('skinCenterLeft').style.height = yd + 205;
        document.getElementById('skinCenterMiddle').style.height = yd + 205;
        document.getElementById('skinCenterRight').style.height = yd + 205;
        document.getElementById('todolist').style.height = yd + 200 + "px";
        
    window.resizeTo(x - 1,y - 1); window.resizeTo(x,y);
    
}

function resizeCompleted(){
    
    updateToDoData();
 
    var x = window.innerWidth;
    var y = window.innerHeight;
    gDetailSheet.setRect(45,57,x - 90,y - 95);
    gNewItemSheet.setRect((x/2) - 110,57,220,100);

    var dx = (x > 450) ? 450 : x; 
    var dy = (y > 400) ? 400 : y;
    gNewItemDetailedSheet.setRect((x/2) - (dx/2) + 45 ,57,dx - 90 ,dy - 95);
    
    gClusterListSheet.setRect((x/2) - 115,57,230,175);
    gDeleteSheet.setRect((x/2) - 100,57,200,75);
    gSendEmailSheet.setRect((x/2) - 100,57,200,80);
    document.getElementById('alert').style.left = ((x/2) - 30) + "px";
}

function resizeMouseDown(){
    document.addEventListener("mousemove", resizeMouseMove, true);
    document.addEventListener("mouseup", resizeMouseUp, true);
}

function resizeMouseMove(){
    resizeWidget(event.x + 20, event.y + 25);
}

function resizeMouseUp(){
    document.removeEventListener("mousemove", resizeMouseMove, true);
    document.removeEventListener("mouseup", resizeMouseUp, true);
    resizeCompleted();
    if (event.x > STOCK_WIDTH) { gP.setPref("widgetWidth", event.x);}else{gP.setPref("widgetWidth", STOCK_WIDTH);}
    if (event.y > STOCK_HEIGHT) { gP.setPref("widgetHeight", event.y);}else{ gP.setPref("widgetHeight", STOCK_HEIGHT);}
}

function resizeDblClick(){
    gP.setPref("widgetWidth", STOCK_WIDTH); gP.setPref("widgetHeight", STOCK_HEIGHT);
    resizeWidget(STOCK_WIDTH, STOCK_HEIGHT); resizeCompleted();
}


function mousemove()
{  
	if (!flipShown)
	{
		// fade in the flip widget
		if (flipAnimation.timer != null)
		{
			clearInterval (flipAnimation.timer);
			flipAnimation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; // set it back one frame
		
		flipAnimation.duration = 200;
		flipAnimation.starttime = starttime;
		flipAnimation.toolBar = document.getElementById('toolBar');
		flipAnimation.timer = setInterval ("flipAnimate();", 13);
		flipAnimation.from = flipAnimation.now;
		flipAnimation.to = 0.90;
		flipAnimate();
		flipShown = true;
	}

}

function mouseexit()
{
    if (event.target.nodeType != 1) return;
	if (flipShown)
	{
		// fade in the flip widget
		if (flipAnimation.timer != null)
		{
			clearInterval (flipAnimation.timer);
			flipAnimation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; // set it back one frame
		
		flipAnimation.duration = 3000;
		flipAnimation.starttime = starttime;
		flipAnimation.toolBar = document.getElementById ('toolBar');
		flipAnimation.timer = setInterval ("flipAnimate();", 13);
		flipAnimation.from = flipAnimation.now;
		flipAnimation.to = 0.0;
		flipAnimate();
		flipShown = false;
	}
}


function flipAnimate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	T = limit_3(time-flipAnimation.starttime, 0, flipAnimation.duration);
	
	if (T >= flipAnimation.duration)
	{
		clearInterval (flipAnimation.timer);
		flipAnimation.timer = null;
		flipAnimation.now = flipAnimation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / flipAnimation.duration));
		flipAnimation.now = computeNextFloat (flipAnimation.from, flipAnimation.to, ease);
	}
	
	flipAnimation.toolBar.style.opacity = flipAnimation.now;
}

function limit_3 (a, b, c) {
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease) {
    return from + (to - from) * ease;
}


