
function balloon(){}

balloon.prototype._body = null;
balloon.prototype._bubblediv = null;
balloon.prototype._bubbleInnerdiv = null;
balloon.prototype._dropShadow = [];
balloon.prototype._x = null;
balloon.prototype._y = null;
balloon.prototype._enabled = null;
balloon.prototype._showTimeout = null;
balloon.prototype._hideTimeout = null;


balloon.prototype.baseInit = function(){
    
    if (this._body) return;
    
    this._body = document.getElementsByTagName("body").item(0);
    
    this._bubblediv = document.createElement("div");
    
    this._body.appendChild(this._bubblediv);
    
    addClass(this._bubblediv, "balloon");
    
    this._bubblediv.addEventListener("mouseover", cmr(this, "balloonMouseOver"), false);
    
    for(var i = 0; i < 10; i++){
        this._dropShadow[i] = document.createElement("div");
        this._bubblediv.appendChild(this._dropShadow[i]);
        this._dropShadow[i].setAttribute("class", "dropShadow");
        this._dropShadow[i].style.right = i;
        this._dropShadow[i].style.bottom = i;
    }
    
    
    this._bubbleInnerdiv = document.createElement("div");
    
    this._bubblediv.appendChild(this._bubbleInnerdiv);
    
    addClass(this._bubbleInnerdiv, "balloonInner");
    
    this.resize(180, 110);
    
    this._enabled = true;
    
    this.hide();

}

balloon.prototype.resize = function(width, height){
    
    this._bubblediv.style.width = width + "px";
    
    this._bubblediv.style.height = height + "px";
    
    for(var i = 0; i < 10; i++){
        this._dropShadow[i].style.width = width - 10 + "px";
        this._dropShadow[i].style.height = height - 10 + "px";   
    }
    
    this._bubbleInnerdiv.style.width = width - 10 + "px";
    
    this._bubbleInnerdiv.style.height = height - 10 + "px";

}


balloon.prototype.balloonMouseOver = function(){
    
    this.hide();
    
}

balloon.prototype.show = function(){
    
    this.position();

    this._bubblediv.style.visibility = "visible";
    
    if (this._hideTimeout) clearTimeout(this._hideTimeout);
    
    this._hideTimeout = setTimeout(cmr(this, "hide"), 20000);
    
}

balloon.prototype.position = function(){
   
    this._bubblediv.style.top = this._y - 10;
    
    this._bubblediv.style.left = this._x + 15;
    
    if (this._bubblediv.clientWidth + this._x > this._body.clientWidth) this._bubblediv.style.left = this._x - this._bubblediv.clientWidth - 5;
    
    if (this._bubblediv.clientHeight + this._y > this._body.clientHeight) this._bubblediv.style.top = this._y - this._bubblediv.clientHeight;    

}


balloon.prototype.hide = function(){

    if (this._showTimeout) clearTimeout(this._showTimeout);

    this._bubblediv.style.visibility = "hidden";
    
}

balloon.prototype.disable = function(){
    
    this.hide();

    this._enabled = false;

}

balloon.prototype.enable = function(){

    this._enabled = true;

}

balloon.prototype.activate = function(){

    if (this._showTimeout){
    
        clearTimeout(this._showTimeout);
        
        this.hide();
        
    }
    
    this._showTimeout = setTimeout(cmr(this, "show"), 700);
    
}



/////

function taskBalloon(){

    var _task = null;
    var _divider = null;
    var _note = null;
    var _taskUid = null;
    
    this.init = function(){
    
        this.baseInit();
        
        this._task = document.createElement("div");
        this._task.setAttribute("id", "taskBalloon_task");
        this._bubbleInnerdiv.appendChild(this._task);
        
        this._divider = document.createElement("div");
        this._divider.setAttribute("id", "taskBalloon_line");
        this._bubbleInnerdiv.appendChild(this._divider);
        
        this._note = document.createElement("div");
        this._note.setAttribute("id", "taskBalloon_note");
        this._bubbleInnerdiv.appendChild(this._note);
        
    }
    
    this.updateBalloonData = function(taskUid, e){
        
        this._x = e.clientX;
        
        this._y = e.clientY;
        
        if (this._enabled = false) return;
        
        var ret = dobedoPlug.getTaskData(taskUid, taskUid);
    
        this._task.innerHTML = getat(ret, "summary");
    
        this._note.innerHTML = getat(ret, "note");

        this._divider.style.display = (this._note.innerHTML.length > 0) ? "block" : "none";
        
        this._taskUid = taskUid;
        
        var psize = (this._task.innerHTML.length + this._note.innerHTML.length) * 90;
        
        psize = Math.sqrt(psize);
        
        if (psize < 60) psize = 60;
        
        var width = psize * 1.6;
        
        var height = psize;
        
        if (width > this._body.clientWidth * 0.45) width = this._body.clientWidth * 0.45;
    
        if (height > this._body.clientHeight * 0.45) height = this._body.clientHeight * 0.45;
        
        this.resize(width, height);
        
    }
   
    
    
}

taskBalloon.prototype = new balloon;


