
function BHDialog(){}
BHDialog.prototype = new BHSheet();
BHDialog.prototype.draw = function(){}

BHDialog.prototype.dialogInit = function(modalCoverRect){
    this._stretchModal = false;
    this._cover.setAttribute("class", "dialogCover");
    this._sheetDiv.setAttribute("class", "dialogDiv");
    if (modalCoverRect){
        this._cover.style.top = modalCoverRect.top;
        this._cover.style.left = modalCoverRect.left;
        this._cover.style.height = modalCoverRect.height;
        this._cover.style.width = modalCoverRect.width;
    }
}

BHDialog.prototype.show = function(){
        this._cover.style.display = "block";
        this._sheetDiv.style.display = "block";
}

///////////////////////////////////////////////////////////

function BHAlertDialog(){
    var _msg = null;
    var _okButton = null;
    
    this.init = function(name, modalCoverRect){
        this.baseInit(name);
        this.dialogInit(modalCoverRect);
        var idiv = document.createElement("div");
        this._sheetDiv.appendChild(idiv);
        idiv.innerHTML = "<div style='position:relative;'><div class='alertDialogMessage' id='alertdialogmsg" + name + "'></div><div class='alertDialogButton' id='alertDialogOk" + name + "'></div></div>";
        _msg = document.getElementById("alertdialogmsg" + name);
        _okButton = abutton(document.getElementById("alertDialogOk" + name), "Ok", createMethodReference(this, "okClicked"));
    }
    
    this.showAlert = function(msg){
        _msg.innerHTML = msg;
        this.show();
    }
    
    this.okClicked = function(){
        this.hideSheet();
    }
    
}

BHAlertDialog.prototype = new BHDialog();

//////////////////////////////////////////////////////////


function BHConfirmationDialog(){
    var _msg = null;
    var _yesButton = null;
    var _noButton = null;
    var _yesCallback = null;
    
    this.init = function(name, modalCoverRect, yesFunction){
        this.baseInit(name);
        this.dialogInit(modalCoverRect);
        var idiv = document.createElement("div");
        this._sheetDiv.appendChild(idiv);
        idiv.innerHTML = "<div style='position:relative;'><div class='alertDialogMessage' id='alertdialogmsg" + name + "'></div><div class='alertDialogButton'><div class='confirmDialogButtonNo' id='confirmDialogNo" + name + "'></div><div class='confirmDialogButtonYes' id='confirmDialogYes" + name + "'></div></div></div>";
        _msg = document.getElementById("alertdialogmsg" + name);
        _noButton = abutton(document.getElementById("confirmDialogNo" + name), "No", createMethodReference(this, "noClicked"));
        _yesButton = abutton(document.getElementById("confirmDialogYes" + name), "Yes", createMethodReference(this, "yesClicked"));
        _yesCallback = yesFunction;
    }
    
    this.showConfirm = function(msg){
        _msg.innerHTML = msg;
        this.show();
    }
    
    this.yesClicked = function(){
        this.hideSheet();
        _yesCallback();
    }
    
    this.noClicked = function(){
        this.hideSheet();
    }
    
}

BHConfirmationDialog.prototype = new BHDialog();

