
function BHPopCal(){}

BHPopCal.prototype._cal = null;
BHPopCal.prototype._parentContainer = null;
BHPopCal.prototype._daysOfTheWeek = new Array("Su","Mo","Tu","We","Th","Fr","Sa");
BHPopCal.prototype._months = new Array("January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December");
BHPopCal.prototype._daysInMonth = new Array(31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
BHPopCal.prototype._cells = null;
BHPopCal.prototype._calTable = null;
BHPopCal.prototype._monthLeft = null;
BHPopCal.prototype._monthRight = null;
BHPopCal.prototype._monthLabel = null;
BHPopCal.prototype._monthCell = null;
BHPopCal.prototype._callBack = null;
BHPopCal.prototype._displayDate = null;

BHPopCal.prototype.init = function(container, onClickCallBack){
    this._cal = document.createElement("div");
    this._cal.setAttribute("class", "popCal");
    
    this._parentContainer = container;
    this._parentContainer.appendChild(this._cal);
    
    this._displayDate = new Date();
    this._displayDate.setDate(1);
    
    this._calTable = document.createElement("table");
    this._calTable.setAttribute("class", "popCal");
    this._calTable.setAttribute("width", "100%");
    this._calTable.setAttribute("cellspacing", "0");
    this._calTable.setAttribute("cellpadding", "0");
    this._cal.appendChild(this._calTable);
    
    var yearRow = document.createElement("tr");
    this._calTable.appendChild(yearRow);
    
    this._monthLeft = document.createElement("span");
    this._monthLeft.setAttribute("class", "popCalMonthArrow popCalMonthArrowLeft");
    this._monthLeft.addEventListener("click", createMethodReference(this, "backOneMonth"), false);
    this._monthLeft.innerHTML = "<<  ";

    this._monthLabel = document.createElement("span");
    this._monthLabel.setAttribute("class", "popCalMonthHeader");
    this._monthLabel.innerHTML = this._months[this._displayDate.getMonth()];
    this._monthLabel.addEventListener("click", createMethodReference(this, "resetToToday"), false);
    
    this._monthRight = document.createElement("span");
    this._monthRight.setAttribute("class", "popCalMonthArrow popCalMonthArrowRight");
    this._monthRight.addEventListener("click", createMethodReference(this, "forwardOneMonth"), false);
    this._monthRight.innerHTML = "  >>";
        
    this._monthCell = document.createElement("td");
    this._monthCell.setAttribute("colspan", "7"); this._monthCell.setAttribute("align", "center");
    this._monthCell.appendChild(this._monthLeft); this._monthCell.appendChild(this._monthLabel); this._monthCell.appendChild(this._monthRight);
    yearRow.appendChild(this._monthCell); 
    
    var dayRow = document.createElement("tr");
    dayRow.setAttribute("class", "popCalDayRow");
    this._calTable.appendChild(dayRow);
    
    this._months = dobedoPlug.monthSymbols().split(",");
    this._daysOfTheWeek = dobedoPlug.weekdaySymbols().split(",");
        
    for (var i = 0; i < 7; i++){
        var dcell = document.createElement("td");
        dayRow.appendChild(dcell);
        dcell.innerHTML = this._daysOfTheWeek[i];
    }
    
    this._cells = new Array();
    for (var r = 0 ; r < 6; r++){
        var row = document.createElement("tr");
        for(var c = 0; c < 7; c++){
            var cell = document.createElement("td");
            cell.setAttribute("class", "popCalDayBlock");
            row.appendChild(cell);
            this._cells.push(cell);
            cell.addEventListener("click", createMethodReference(this, "cellClicked"), false);
        }
        this._calTable.appendChild(row);
    }
    
    this._callBack = onClickCallBack;
    
    
    this.renderGrid();
}

BHPopCal.prototype.renderGrid = function(){
    var d = 1;
    var tdy = new Date();
    this._monthLabel.innerHTML = this._months[this._displayDate.getMonth()] + " " + this._displayDate.getFullYear();
    var firstDrawableDayOfTheWeek = this._displayDate.getDay();
    var daysInTheCurrentMonth = this._daysInMonth[this._displayDate.getMonth()] + firstDrawableDayOfTheWeek;
    
    if (this._displayDate.getFullYear() % 4 == 0 && this._displayDate.getMonth() == 1){
        daysInTheCurrentMonth++;
    }
    
    for(var i = 0; i < this._cells.length; i++){
        if (i >= firstDrawableDayOfTheWeek && i < daysInTheCurrentMonth){
            this._cells[i].innerHTML = d++;
        }else{
            this._cells[i].innerHTML = "";
        }
        if (tdy.getDate() == d - 1 && tdy.getMonth() == this._displayDate.getMonth() && tdy.getFullYear() == this._displayDate.getFullYear()){
            this._cells[i].style.color = "#EF0000";
        }else{
            this._cells[i].style.color = "#000000";
        }
    }
    
}

BHPopCal.prototype.cellClicked = function(){
    var d = event.target.innerHTML;
    if (d.length < 1) return;
    var rdate = new Date(this._displayDate.getFullYear(), this._displayDate.getMonth(), d);
    if (this._callBack instanceof Function) this._callBack(rdate);
}

BHPopCal.prototype.backOneMonth = function(){
    if (this._displayDate.getMonth() == 0){
        this._displayDate.setMonth(11);
        this._displayDate.setFullYear(this._displayDate.getFullYear() - 1);
    }else{
        this._displayDate.setMonth(this._displayDate.getMonth() - 1);
    }
    this.renderGrid();
}

BHPopCal.prototype.forwardOneMonth = function(){
    if (this._displayDate.getMonth() == 11){
        this._displayDate.setMonth(0);
        this._displayDate.setFullYear(this._displayDate.getFullYear() + 1);
    }else{
        this._displayDate.setMonth(this._displayDate.getMonth() + 1);
    }
    this.renderGrid();
}

BHPopCal.prototype.resetToToday = function(){
    this._displayDate = new Date();
    this._displayDate.setDate(1);
    this.renderGrid();
}


