
function BHSheet(){}

BHSheet.prototype._x = 0;
BHSheet.prototype._y = 0;
BHSheet.prototype._height = 0;
BHSheet.prototype._width = 0;
BHSheet.prototype._name = "";
BHSheet.prototype._body = null;
BHSheet.prototype._cover = null;
BHSheet.prototype._sheetDiv = null;
BHSheet.prototype._sheetBackground = null;
BHSheet.prototype._defaultResponder = null;
BHSheet.prototype._stretchModal = true;
BHSheet.prototype._animate = true;
BHSheet.prototype._aniPack = {animating:false, timer:null, frames:8, current_frame:0};

BHSheet.prototype.baseInit = function(name){

        if (this._body) return;
        this._name = name;
        this._body = document.getElementsByTagName("body").item(0);
        ///////
        this._cover = document.createElement("div");
        this._cover.setAttribute("class", "sheetCover");
        this._cover.setAttribute("id", "sheetCover" + name);
        this._cover.addEventListener("click", createMethodReference(this, "coverClicked"), false);
        this._body.appendChild(this._cover);
        this.pullCoverTight();
        ///////
        this._sheetDiv = document.createElement("div");
        this._sheetDiv.setAttribute("class", "sheetDiv");
        this._sheetDiv.setAttribute("id", "sheetDiv" + name);
        this._body.appendChild(this._sheetDiv);     
        //////
        this._sheetBackground = document.createElement("div");
        this._sheetBackground.setAttribute("class", "sheetBackground");
        this._sheetBackground.setAttribute("id", "sheetBackground" + name);
        this._sheetBackground.addEventListener("click", createMethodReference(this, "sheetClicked"), false);
        this._sheetDiv.appendChild(this._sheetBackground);     
        //////
        this.hideSheet();
}

BHSheet.prototype.pullCoverTight = function(){
        this._cover.style.top = 0;
        this._cover.style.left = 0;
        this._cover.style.height = window.innerHeight;
        this._cover.style.width = window.innerWidth;
}

BHSheet.prototype.setCoverRect = function(cvr){
        this._cover.style.top = cvr.top;
        this._cover.style.left = cvr.left;
        this._cover.style.height = cvr.height;
        this._cover.style.width = cvr.width;
}

BHSheet.prototype.hideSheet = function(){
        this._cover.style.display = "none";
        this._sheetDiv.style.display = "none";          
}

BHSheet.prototype.draw = function(){
        if (this._aniPack.current_frame < this._aniPack.frames){
            var x = parseInt(this._height) - this._y + parseInt(this._sheetDiv.style.top);
            this._sheetDiv.style.top = parseInt(this._sheetDiv.style.top) + parseInt((parseInt(this._height) - x)/2.2);
            this._aniPack.current_frame++;
        }else{
            this._sheetDiv.style.top = this._y;
            clearInterval(this._aniPack.timer);
            this._aniPack.animating = false;
        }     
       this._sheetDiv.style.clip = "rect(" + (parseInt(this._y) - parseInt(this._sheetDiv.style.top)) + " auto auto auto)";
}

BHSheet.prototype.show = function(){
        this._cover.style.display = "block";
        this._sheetDiv.style.display = "block"; 
        (this._height * this._width < 200000) ? this._aniPack.frames = 8 : this._aniPack.frames = 3;
        this._aniPack.current_frame = 0; 
        if (this._animate){
            this._sheetDiv.style.top = parseInt(this._y) - parseInt(this._height);
            this._sheetDiv.style.clip = "rect(" + (parseInt(this._y) - parseInt(this._sheetDiv.style.top)) + " auto auto auto)";
            this._aniPack.animating = true;
            this._aniPack.timer = setInterval(createMethodReference(this, "draw"), 16);
        }
}

BHSheet.prototype.setAnimates = function(tf){
        this._animate = tf;
}

BHSheet.prototype.sheetClicked = function(){}

BHSheet.prototype.coverClicked = function(){
        if (!this._defaultResponder) return;
        this._defaultResponder.focus();
}

BHSheet.prototype.setRect = function(x,y,w,h){
        if (!this._cover) return;
        this._x = x; this._y = y; this._height = h; this._width = w;

        this._sheetDiv.style.top = this._y;
        this._sheetDiv.style.left = this._x;
        this._sheetDiv.style.height = this._height;
        this._sheetDiv.style.width = this._width;
        
        if (this._stretchModal) this.pullCoverTight();
}


//////////////////////////////////////////////////////////////////////////////////////////////

function newItemSheet(){
    var _taskText = null;
    var _calValue = null;
    var _calSelect = null;
    var _lastCalSelected = null;

    this.init = function(name){
        this.baseInit(name);
        var idiv = document.createElement("div");
        this._sheetDiv.appendChild(idiv);
        var ihtml = "<div class='newItemSheet newItemSheetLabel'>Task:</div><input type='text' class='newItemSheet newItemSheetInput'><div class='newItemSheet newItemSheetLabel'>Calendar:</div><div class='newItemSheet newItemSheetValueFace'><span class='newItemSheetValueSpan'></span><select class='newItemSheetValueSelect'><option></option></select></div><div class='newItemSheet newItemSheetButtons'><div id='newItemSheetCancelButton'></div><div id='newItemSheetAcceptButton' class='abuttons'></div></div>"
        idiv.innerHTML = ihtml;
        
        _taskText = idiv.getElementsByTagName('input')(0);
        _taskText.addEventListener("keypress", createMethodReference(this, "taskKeyPressed"), false);
        this._defaultResponder = _taskText; 
        
        _calSelect = idiv.getElementsByTagName('select')(0);  
        _calSelect.addEventListener("change", createMethodReference(this, "calChanged"), false);
        _calSelect.addEventListener("keypress", createMethodReference(this, "calSelectKeyPressed"), false);
        
        _calValue = idiv.getElementsByTagName('span')(0);
        
        abutton(document.getElementById('newItemSheetCancelButton'), "Cancel", createMethodReference(this, "cancelClicked"));
        abutton(document.getElementById('newItemSheetAcceptButton'), "Accept", createMethodReference(this, "acceptClicked"));
    }
    
    
    this.cleanSheet = function(){
        _taskText.value = "";
        if(currentCal().isGroup()){
            fillSelectWithAGroupsCalendars(_calSelect, currentCal(), _lastCalSelected);
        }else{
            fillSelectWithCalendars(_calSelect, currentCal().getSourceKey());
        }
        if(_calSelect.options[_calSelect.selectedIndex]) _calValue.innerHTML = _calSelect.options[_calSelect.selectedIndex].text;
    }
    
    this.showSheet = function(){
        addKeyListener("newitemKey", createMethodReference(this, "keyDownHandler"));
        this.cleanSheet();
        this.show();   
        _taskText.blur();
        setTimeout(cmr(this,"setMainFocus"), 200);
    }
    
    this.setMainFocus = function(){
        _taskText.focus();
    }
    
    this.calChanged = function(){
        _lastCalSelected = _calSelect.value;
        _calValue.innerHTML = _calSelect.options[_calSelect.selectedIndex].text;
    }
    
    this.taskKeyPressed = function(){
        if (event.keyCode == 3 || event.keyCode == 13) {
            this.acceptClicked();
        }
    }
    
    this.calSelectKeyPressed = function(){
        if (event.keyCode == 9) event.preventDefault();   
    }
    
    this.cancelClicked = function(){
        this.closeSheet();
    }
    
    this.closeSheet = function(){
        removeKeyListener("newitemKey", createMethodReference(this, "keyDownHandler"));
        this.hideSheet();
    }
    
    this.acceptClicked = function(){
        if (!_calSelect.value || _taskText.value.length == 0) {_taskText.focus();return;}
        var t = dobedoPlug.addNewToDo(_calSelect.value, _taskText.value, gP.gp("nlp"));
        updateToDoData();
        turnPageToItem(t);
        this.closeSheet();
    }
    
    this.keyDownHandler = function(){
        switch(event.keyCode){
            case 37:
                event.stopPropagation();
                break;
            case 38:
                event.stopPropagation();
                break;
        }
        
        event.hijacked = true;
        
        if (event.metaKey && event.charCode == 115) this.acceptClicked();
        
    }
    
}
newItemSheet.prototype = new BHSheet();


//////////////////////////////////////////////////////////////////////////////////////////////

function emailSendSheet(){

    _emailAddressInput = null;
    
    this.init = function(name){
        this.baseInit(name);
        var idiv = document.createElement("div");
        this._sheetDiv.appendChild(idiv);
        var ihtml = "<div style='position:absolute;top:8px;left:12px;' class='emailSendSheet'><div class='emailSendLabel'>Email Address:</div><input type='text' id='emailSendAddressInput'><div id='emailSendCancelButton' class='abuttons'></div><div id='emailSendSendButton' class='abuttons'></div></div>"
        idiv.innerHTML = ihtml;
        
        _emailAddressInput = document.getElementById('emailSendAddressInput');

        this._defaultResponder = _emailAddressInput; 
               
        abutton(document.getElementById('emailSendCancelButton'), "Cancel", createMethodReference(this, "cancelClicked"));
        abutton(document.getElementById('emailSendSendButton'), "Send", createMethodReference(this, "sendClicked"));
    }
    
    this.showSheet = function(){
        addKeyListener("sendEmailKey", createMethodReference(this, "keyDownHandler"));
        if (gP.getGlobalPref("lastEmailAddress")) _emailAddressInput.value = gP.getGlobalPref("lastEmailAddress");
        this.show();
        this._defaultResponder.focus();
        
    }
    
    this.cancelClicked = function(){
        this.closeSheet();
    }
    
    this.closeSheet = function(){
        removeKeyListener("sendEmailKey", createMethodReference(this, "keyDownHandler"));
        this.hideSheet();
    }
    
    this.validEmailAddress = function(e){
        var et = /^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{1,5})+$/;
        return et.test(e);
    }
    
    this.sendClicked = function(){
        if (!_emailAddressInput.value || !this.validEmailAddress(_emailAddressInput.value)){
            _emailAddressInput.focus();
            return;
        }
        
        dobedoPlug.todoListHTML(currentCal().getSourceKey() , gP.gp("sort"), 0, gFuturePack.visible ? 1000000 : gP.gp("futureDays"), gP.gp("showPriorityAndDueDate"), 4, "<emailaddress>" + _emailAddressInput.value + "</emailaddress><nodetitle>" + currentCal().getTitle() + "</nodetitle><recordfilter>" + gSelected.join(",") + "</recordfilter>");
        
        gP.setGlobalPrefForKey(_emailAddressInput.value, "lastEmailAddress");
        
        this.closeSheet();
    }
    
    this.keyDownHandler = function(){
        switch(event.keyCode){
            case 37:
                event.stopPropagation();
                break;
            case 38:
                event.stopPropagation();
                break;
        }
        event.hijacked = true;
    }
    
}
emailSendSheet.prototype = new BHSheet();



/////////////////////////////////////////////////////////////////////////////////////


function deleteItemSheet(){
    var _msgSpan = null;
    var _noButton = null;
    var _yesButton = null;
    var _itemUID = null;
    var _calid = null;
    
    this.init = function(name){
        this.baseInit(name);
        var idiv = document.createElement("div");
        this._sheetDiv.appendChild(idiv);
        var ihtml = " <div class='deleteSheet'> <span id='deleteMsg'>Delete ?</span> </div><div class='deleteSheetButtons'><div id='deleteSheetNo' class='abuttons'></div><div id='deleteSheetYes' class='abuttons'></div></div>";
        idiv.innerHTML = ihtml;
        
        _msgSpan = idiv.getElementsByTagName('span')(0);
        
        _noButton = abutton(document.getElementById('deleteSheetNo'), "No", createMethodReference(this, "noClicked"));
        _yesButton = abutton(document.getElementById('deleteSheetYes'), "Yes", createMethodReference(this, "yesClicked"));
    }
    
    this.setItem = function(msg, uid, multiple){
        var stringLength = 36;
        var tmpString = "";
        
        if (multiple){
            tmpString = "selected items";
        }else{
            (msg.length > stringLength) ? tmpString = String(msg).substring(0, stringLength) + "..." : tmpString = msg;
        }
        
        _msgSpan.innerHTML = "Delete \"" + tmpString + "\" ?";
        _itemUID = uid;
    }
    
    this.showSheet = function(){
        addKeyListener("deleteKey", createMethodReference(this, "keyDownHandler"));
        this.show(); 
    }
    
    this.closeSheet=  function(){
        removeKeyListener("deleteKey", createMethodReference(this, "keyDownHandler"));
        this.hideSheet();
    }
    
    this.noClicked = function(){
        this.closeSheet();
    }

    this.yesClicked = function(){
        if (!_itemUID) return;
        
        dobedoPlug.deleteToDo("filler", _itemUID);
        
        this.closeSheet();
        
        deSelectAll();
        
        updateToDoData();
    }
    
    this.keyDownHandler = function(){
    
        switch(event.keyCode){
            case 78:
                this.noClicked();
                event.stopPropagation();
                break;
            case 89:
                this.yesClicked();
                event.stopPropagation();
                break;
        }
        
        event.hijacked = true;
    }
    
    
}
deleteItemSheet.prototype = new BHSheet();


//////////////////////////////////////////////////////////////


function calendarSheet(){
        
    this.init = function(name, callback){
        this.baseInit(name);
        this._callback = callback;
        this._pcal = new BHPopCal();
        this._pcal.init(this._sheetDiv, createMethodReference(this, "dateSelected"));
        this._lastshown = new Date().getTime();
    }
    
    this.showSheet = function(){
        if (new Date().getTime() - this._lastshown >  7000)this._pcal.resetToToday();
        addKeyListener("calKey", createMethodReference(this, "keyDownHandler"));
        this.show();
    }
    
    this.dateSelected = function(dt){
        this._callback(dt);
        this.closeSheet();
    }
    
    this.keyDownHandler = function(){
        switch(event.keyCode){
            case 27:
                this.closeSheet();
                break;
            case 37:
                this._pcal.backOneMonth();
                event.preventDefault();
                break;
            case 38:
                this._pcal.backOneMonth();
                event.preventDefault();
                break;
            case 39:
                this._pcal.forwardOneMonth();
                event.preventDefault();
                break;
            case 40:
                this._pcal.forwardOneMonth();
                event.preventDefault();
                break;
        }
        
        event.hijacked = true;
    }
    
    this.coverClicked = function(){
        this.closeSheet();    
    }
    
    this.closeSheet = function(){
        this._lastshown = new Date().getTime();
        removeKeyListener("calKey", createMethodReference(this, "keyDownHandler"));
        this.hideSheet();
    }
    
}
calendarSheet.prototype = new BHSheet();




////////////////////////////////////////////////////////////////////


function priorityPopUpSheet(){
        
    this.init = function(name, callback){
        this.baseInit(name);
        this.setAnimates(false);
        this._callback = callback;
        this._sheetDiv.style.borderTopWidth = "1px";
        var idiv = document.createElement("div");
        idiv.setAttribute("id", "priorityPopUp");
        this._sheetDiv.appendChild(idiv);
        this._priorityValue = "0";
        
        var ihtml = "<div class='priorityPopUpItem' id='priorityPopUpItem1'>High</div><div id='priorityPopUpItem2' class='priorityPopUpItem'>Medium</div><div id='priorityPopUpItem3' class='priorityPopUpItem'>Low</div><div id='priorityPopUpItem4' class='priorityPopUpItem'>None</div>";
        
        idiv.innerHTML = ihtml;
        
        document.getElementById('priorityPopUpItem1').addEventListener("mouseover", createMethodReference(this, "priorityPopUpItemMouseOver"), false);
        document.getElementById('priorityPopUpItem2').addEventListener("mouseover", createMethodReference(this, "priorityPopUpItemMouseOver"), false);
        document.getElementById('priorityPopUpItem3').addEventListener("mouseover", createMethodReference(this, "priorityPopUpItemMouseOver"), false);
        document.getElementById('priorityPopUpItem4').addEventListener("mouseover", createMethodReference(this, "priorityPopUpItemMouseOver"), false);
        
        document.getElementById('priorityPopUpItem1').addEventListener("click", createMethodReference(this, "itemClicked"), false);
        document.getElementById('priorityPopUpItem2').addEventListener("click", createMethodReference(this, "itemClicked"), false);
        document.getElementById('priorityPopUpItem3').addEventListener("click", createMethodReference(this, "itemClicked"), false);
        document.getElementById('priorityPopUpItem4').addEventListener("click", createMethodReference(this, "itemClicked"), false);
    }
    
    this.priorityPopUpItemMouseOver = function(){
        highLightSelectedElement(document.getElementById('priorityPopUp'), event.target.id, true);
    }
    
    this.itemClicked = function(){
        this.closeSheet();
        switch(event.target.id){
            case "priorityPopUpItem1":
                this._priorityValue = "1";
                break;
            case "priorityPopUpItem2":
                this._priorityValue = "5";
                break;
            case "priorityPopUpItem3":
                this._priorityValue = "9";
                break;
            default:
                this._priorityValue = "0";             
                break;
        }
        this._callback(event.target);
    }
    
    this.showSheet = function(){
        addKeyListener("priorityPopUpKey", createMethodReference(this, "keyDownHandler"));
        indicateSelectedElement(document.getElementById('priorityPopUp'), "nil");
        this.show();
    }

    this.closeSheet = function(){
        removeKeyListener("priorityPopUpKey", createMethodReference(this, "keyDownHandler"));
        this.hideSheet();
    }
    
    this.coverClicked = function(){
        this.closeSheet();    
    }
    
    this.keyDownHandler = function(){
        switch(event.keyCode){
            case 27:
                this.closeSheet();
                break;
        }
        event.hijacked = true;
    }    
}
priorityPopUpSheet.prototype = new BHSheet();


//////////////////////////////////////////////////////////////////////


function itemDetailSheet(){
    var _taskText = null;
    var _calSelect = null;
    var _calLabel = null;
    var _prioritySelect = null;
    var _priorityLabel = null;
    var _dueSelect = null;
    var _dueLabel = null;
    var _urlLabel = null;
    var _urlText = null;
    var _noteText = null;
    var _pcalIcon = null;
    var _pcalSheet = null;
    var _pcalValue = "na";
    var _lastCalSelected = null;
    var _newItem = false;

    this.init = function(name){
        this.baseInit(name); 
        var idiv = document.createElement("div");
        this._sheetDiv.appendChild(idiv);
        
        ihtml = " <div class='detailSheet'> <div class='detailSheetRow detailSheetSmallRow'><div class='detailSheetLabel'>Task:</div><div class='detailSheetVal'><input type='text' class='detailSheetValueInput detailSheetValueInputTask' tabindex='1'></div></div> <div class='detailSheetRow detailSheetSmallRow'><div class='detailSheetLabel'>Calendar:</div><div class='detailSheetVal detailSheetFace'><span class='detailSheetValueSpan'>a</span><select class='detailSheetValueSelect'><option>b</option></select></div></div> <div class='detailSheetRow detailSheetSmallRow'><div class='detailSheetLabel'>Priority:</div><div class='detailSheetVal detailSheetFace'><span class='detailSheetValueSpan'>a</span><select class='detailSheetValueSelect'><option>b</option></select></div></div> <div class='detailSheetRow detailSheetSmallRow'><div class='detailSheetLabel'>Due Date:</div><div class='detailSheetVal detailSheetFace'><span class='detailSheetValueSpan'>a<div id='calIcon'></div></span><select class='detailSheetValueSelect detailSheetDueSelect'><option>b</option></select><div id='pcalIcon'></div></div></div> <div class='detailSheetRow detailSheetSmallRow'><div class='detailSheetLabel'><span>URL:</span></div><div class='detailSheetVal'><input type='text' class='detailSheetValue detailSheetValueInput' tabindex='2'></div></div> <div class='detailSheetRow'><div class='detailSheetLabel'>Notes:</div><div class='detailSheetVal'><textarea class='detailSheetValue detailSheetTextArea' tabindex='3'> </textarea></div></div> </div> <div class='detailSheetButtons'><div id='detailSheetCancel' class='abuttons'></div><div id='detailSheetAccept' class='abuttons'></div></div> "
        
        idiv.innerHTML = ihtml;
        
        _taskText = idiv.getElementsByTagName('input')(0);
        
        this._defaultResponder = _taskText;
        
        _calSelect = idiv.getElementsByTagName('select')(0);
        
        _calSelect.addEventListener("change", createMethodReference(this, "calendarChanged"), false);
        
        _calLabel = idiv.getElementsByTagName('span')(0);
        
        _prioritySelect = idiv.getElementsByTagName('select')(1);
        
        _prioritySelect.innerHTML = "<option value=1>" + "High" + "</option><option value=5>" + "Medium" + "</option><option value=9>" + "Low" + "</option><option value=0>" + "None" + "</option>";
        
        _prioritySelect.addEventListener("change", createMethodReference(this, "priorityChanged"), false);
        
        _priorityLabel = idiv.getElementsByTagName('span')(1);
        
        _dueSelect = idiv.getElementsByTagName('select')(2);
        
        _dueSelect.innerHTML = "<option value=0>" + "Today" + "</option><option value=1>" + "Tomorrow" + "</option><option value=2>" + "2 Days" + "</option><option value=3>" + "3 Days" + "</option><option value=4>" + "4 Days" + "</option><option value=7>" + "One Week" + "</option><option value=14>" + "Two Weeks" + "</option><option value=30>" + "One Month" + "</option><option value=60>" + "2 Months" + "</option><option value=90>" + "3 Months" + "</option><option value=180>" + "6 Months" + "</option><option value=365>" + "1 Year" + "</option><option value=1095>" + "3 Years" + "</option><option value=1825>" + "5 Years" + "</option><option value=\"-1\">" + "None" + "</option>"  + "<option value=-2>" + "------------" + "</option>";
        
        _dueSelect.addEventListener("change", createMethodReference(this, "dueChanged"), false);
        
        _dueLabel = idiv.getElementsByTagName('span')(2);
        
        _urlLabel = idiv.getElementsByTagName('span')(3);
        
        _urlLabel.addEventListener("click", createMethodReference(this, "urlClicked"), false);
        
        _urlText = idiv.getElementsByTagName('input')(1);
        
        _noteText = idiv.getElementsByTagName('textarea')(0);
        
        _pcalIcon = idiv.getElementsByTagName('div')(14);
        _pcalIcon.addEventListener("click", createMethodReference(this, "pcalIconClicked"), false);
        _pcalSheet = new calendarSheet();
        _pcalSheet.init("popupCalendar", createMethodReference(this, "popUpCalDateSelected"));
        _pcalSheet._cover.setAttribute("class", "sheetCover2");
        
        _cancelButton = idiv.getElementsByTagName('div')(22);
        _saveButton = idiv.getElementsByTagName('div')(23);
        
        abutton(_cancelButton, "Cancel", createMethodReference(this, "cancelClicked"));
        abutton(_saveButton, "Save", createMethodReference(this, "acceptClicked"));
    }
    
    this.cleanSheet = function(){
        if (this._height < 225){
           _noteText.style.height = parseInt(this._height - 146) + "px";
        }else{
            _noteText.style.height = parseInt(this._height - 150) + "px";
        }
    }
    
    this.loadSheet = function(uid){
        _newItem = false;
        this._uid = uid;
        var taskData = dobedoPlug.getTaskData("aaaa", uid);
        if (getat(taskData, "error") != "nil") return false;
        _taskText.value = tagDataDecode(getat(taskData, "summary"));
        var taskPriority = getat(taskData, "priority");
        var taskDue = getat(taskData, "due");
        var taskUrl = getat(taskData, "url");
        var taskNote = tagDataDecode(getat(taskData, "note"));
        
        
        fillSelectWithCalendars(_calSelect, getat(taskData, "cid"));
        
        var cn = calNodeFromSourceKey(getat(taskData, "cid"));
        if (cn) _calLabel.innerHTML = cn.getTitle();
        
        for(var i = 0; i < _prioritySelect.length; i++){if (_prioritySelect.options[i].value == taskPriority)_prioritySelect.options[i].selected = true;}
        
        _priorityLabel.innerHTML = _prioritySelect.options[_prioritySelect.selectedIndex].text;
        
        _dueSelect.selectedIndex = _dueSelect.options.length - 1;
        
        _dueLabel.innerHTML = (taskDue == "nil") ? "None" : taskDue;
        
        this._pcalValue = "na";
        
        _urlText.value = taskUrl;

        _noteText.value = "empty"; _noteText.value = taskNote;
        
        return true;
    }
    
    this.loadSheetForNew = function(){
        _newItem = true;
        
        _taskText.value = "";
        
        if(currentCal().isGroup()){
            fillSelectWithAGroupsCalendars(_calSelect, currentCal(), _lastCalSelected);
        }else{
            fillSelectWithCalendars(_calSelect, currentCal().getSourceKey());
        }
        
        if(_calSelect.options[_calSelect.selectedIndex]) _calLabel.innerHTML = _calSelect.options[_calSelect.selectedIndex].text;

        _prioritySelect.options[3].selected = true;
        
        _priorityLabel.innerHTML = _prioritySelect.options[_prioritySelect.selectedIndex].text;
        
        _dueSelect.selectedIndex = _dueSelect.options.length - 2;
        
        _dueLabel.innerHTML = _dueSelect.options[_dueSelect.selectedIndex].text;
        
        this._pcalValue = "na";
        
        _urlText.value = "";

        _noteText.value = "";
        
        return true;
    }


    this.showSheet = function(){
        this.cleanSheet();
        this.show();
        addKeyListener("detailKey", createMethodReference(this, "keyDownHandler"));
        this._defaultResponder.blur();
        setTimeout(cmr(this,"setMainFocus"), 200);
    }
    
    this.setMainFocus = function(){
        this._defaultResponder.focus();
    }
    
    this.calendarChanged = function(){
        _lastCalSelected = _calSelect.value;
        _calLabel.innerHTML = _calSelect.options[_calSelect.selectedIndex].text;
    }
    
    this.priorityChanged = function(){
        _priorityLabel.innerHTML = _prioritySelect.options[_prioritySelect.selectedIndex].text;
    }

    this.dueChanged = function(){
        this._pcalValue = "na";
        _dueLabel.innerHTML = _dueSelect.options[_dueSelect.selectedIndex].text;
    }
    
    this.urlClicked = function(){
        if (_urlText.value.length < 1) {_urlText.focus();return;}
        widget.openURL(_urlText.value);
    }
    
    this.pcalIconClicked = function(){
        var ap = absolutePosition(_pcalIcon);
        var calSize = {x:161,y:110};
        _pcalSheet.setRect(ap.x - calSize.x + 38, ap.y + 18,calSize.x,calSize.y);
        _pcalSheet.showSheet();
    }
    
    this.popUpCalDateSelected = function(sdate){
        this._pcalValue = sdate.getMonth() + 1 + "/" + sdate.getDate() + "/" + sdate.getFullYear();
        _dueLabel.innerHTML = dobedoPlug.localizedDateString(this._pcalValue);    
    }
    
    this.cancelClicked = function(){
        this.closeSheet();
    }
    
    this.acceptClicked = function(){
        if (_newItem){
            this._uid = dobedoPlug.addNewToDo(_calSelect.value, _taskText.value, false);
        }
        
        dobedoPlug.editTaskDetail(this._uid, _calSelect.value, _taskText.value, _prioritySelect.value, _dueSelect.value, this._pcalValue, _urlText.value, _noteText.value);
        
        this.closeSheet();
        updateToDoData();
        turnPageToItem(this._uid);
    }
    
    this.closeSheet = function(){
        this.hideSheet();
        removeKeyListener("detailKey", createMethodReference(this, "keyDownHandler"));    
    }
    
    this.keyDownHandler = function(){
        switch(event.keyCode){
            case 34:
                event.preventDefault();
                event.stopPropagation();
                break;
            case 37:
                event.stopPropagation();
                break;
            case 38:
                event.stopPropagation();
                break;
        }
        event.hijacked = true;
        
        if (event.metaKey && event.charCode == 115) this.acceptClicked();
        
    }

}
itemDetailSheet.prototype = new BHSheet();

////////////////////////////////////////////////////////////////////////////////////


function calEditSheet(){

    var _visibleAlert = null;
    var _currentCal = null;
    var _colorBarWidth = 120;
    var _colorBarHeight = 25;
    var _callback = null;
    var _titleDirty = false;
    
    var _colorChoices = "<option value='#B50D0D'>Red</option><option value='#660C25'>Maroon</option><option value='#B5A867'>Brown</option><option value='#E8E817'>Yellow</option><option value='#AEE817'>Lime</option><option value='#0C8A11'>Green</option><option value='#A1BD8F'>Olive</option><option value='#0C8A85'>Teal</option><option value='#A6D0EC'>Light Blue</option><option value='#0C258A'>Blue</option><option value='#670C8A'>Purple</option><option value='#A5A5A5'>Gray</option><option value=''>------</option><option value='colorbar'>Color Bar</option><option value='hexvalue'>Hex Value</option><option value='' selected>------</option>";
    
    this.init = function(name, callback){
        this.baseInit(name);
        _callback = callback;
        var idiv = document.createElement("div");
        this._sheetDiv.appendChild(idiv);
        var ihtml = "<div class='calManageEditSheet'><div id='calManageEditDismiss'></div><div id='calManageEditRecords'><div class='calManageEditRow'><div class='calManageEditLabel'>Name:</div><div id='calManageEditName' class='calManageEditV'></div></div>";
        ihtml += "<div class='calManageEditRow'><div class='calManageEditLabel'>Type:</div><div id='calManageEditType' class='calManageEditV'></div></div>";
        ihtml += "<div class='calManageEditRow'><div class='calManageEditLabel'>Color:</div><div id='calManageEditColor' class='calManageEditV'></div></div>";
        ihtml += "<div class='calManageEditRow'><div class='calManageEditLabel'>Size:</div><div id='calManageEditSize' class='calManageEditV'></div></div>";
        ihtml += "<div class='calManageEditRow'><div class='calManageEditLabel'>Visible:</div><div id='calManageEditVisible' class='calManageEditV'></div></div>";
        ihtml += "</div></div>";

        idiv.innerHTML = ihtml;
        
        _visibleAlert = new BHAlertDialog(); _visibleAlert.init("avisible", {top:50,left:25,height:272,width:302}); _visibleAlert.setRect(80,120,190,90);
        
        document.getElementById('calManageEditDismiss').addEventListener("click", createMethodReference(this, "dismissed"), false);
    }
    
    this.loadSheet = function(cn){
        _currentCal = cn;
        _titleDirty = false;
        
        document.getElementById('calManageEditName').innerHTML = "<span id='calManageEditNameText' style='position:absolute;cursor:hand;'>" + _currentCal.getTitle() + "</span><input type='text' id='calManageEditNameInput' style='postion:absolute;top:-3px;left:2px;width:90%;visibility:hidden;' value='" + _currentCal.getTitle() + "'>";
        
        if (_currentCal.isNative()){
            document.getElementById('calManageEditNameText').addEventListener("click", createMethodReference(this, "titleClicked"), true);
            document.getElementById('calManageEditNameInput').addEventListener("keyup", createMethodReference(this, "titleKeyed"), true);
        }
        
        document.getElementById('calManageEditType').innerHTML = _currentCal.getTypeFormated();
        
        document.getElementById('calManageEditColor').innerHTML = "<div id='calManageEditColorSwatch' style='width:20px;height:17px;border: 1px solid grey; background-color:" + _currentCal.getThemeColor() + ";'><select id='calManageEditColorSelect'>" + _colorChoices + "</select></div>" + this.createColorBar() + this.createHexValueBox();
        
        for (var i = 0; i < _colorBarWidth; i++){
            document.getElementById('colorBar' + i).addEventListener("mousemove", createMethodReference(this, "colorBarOver"), false);
            document.getElementById('colorBar' + i).addEventListener("click", createMethodReference(this, "colorBarClick"), false);
        }
        
        document.getElementById('calManageEditHexInput').addEventListener("keyup", createMethodReference(this, "hexValueChanged"), false);
        
        document.getElementById('calManageEditSize').innerHTML = this.formatCount(_currentCal.getTotalRecordCount());
        document.getElementById('calManageEditVisible').innerHTML = "<div style='position:absolute;height:20px;width:30px;'>" + ((_currentCal.isVisible()) ? "Yes" : "No") + "</div><div id='calManageEditArrows'></div><select id='calManageEditVisibleSelect' style='opacity:0.0;'><option " + ((_currentCal.isVisible()) ? "selected" : "") + ">Yes</option><option " + ((_currentCal.isVisible()) ? "no" : "selected") + ">No</option></select>";
        
        document.getElementById('calManageEditColorSelect').addEventListener("change", createMethodReference(this, "colorChanged"), false);
        document.getElementById('calManageEditColorSelect').addEventListener("mousedown", createMethodReference(this, "colorMouseDown"), false);
        document.getElementById('calManageEditVisibleSelect').addEventListener("change", createMethodReference(this, "visibleClicked"), false);
        
    }
    
    this.titleClicked = function(){
        document.getElementById('calManageEditNameInput').style.visibility = "visible";
        document.getElementById('calManageEditNameText').style.visibility = "hidden";
        document.getElementById('calManageEditNameInput').focus();
    }
    
    this.titleKeyed = function(){
        _titleDirty = true;
        if (event.keyCode == 13){
            _currentCal.setTitle(document.getElementById('calManageEditNameInput').value);
            this.loadSheet(_currentCal);        
        }
    }
    
    this.createHexValueBox = function(){
        var r = "<div id='calManageEditHexValueBox' style='position:absolute;top:-2px;left:25px;width:100px;visibility:hidden;'>";
        r += "<input type='text' id='calManageEditHexInput' style='position:absolute;width:60px;'>";
        r += "</div>";
        return r;
    }
    
    this.hexValueChanged = function(){
        v = document.getElementById('calManageEditHexInput').value;
        if (v.length != 7) return;
        this.setCalendarColor(document.getElementById('calManageEditHexInput').value);   
    }
    
    this.createColorBar = function(){
        var r = "<div id='calManageEditColorBar' style='position:absolute;top:-4px;left:25px;width:" + _colorBarWidth + "px;height:" + _colorBarHeight + "px;border:1px solid #C7C7C7;visibility:hidden;'>";
        for (var i = 0; i < _colorBarWidth; i++){
            var s = HsvToRgb(i * (360/_colorBarWidth), 100, 100);
            r += "<div id='colorBar" + i + "' hue='" + i * (360/_colorBarWidth) + "' hexColor='#" + rgbToHex(s.red, s.green, s.blue) + "' style='position:absolute;top:0px;left:" + i + "px;width:1px;height:" + _colorBarHeight + "px;background-color:rgb(" + s.red + "," + s.green + "," + s.blue + ");'></div>";
        }
        r += "</div>";
        return r;
    }
    
    this.calculateHSVfromColorBarPosition = function(){
        var cb = absolutePosition(document.getElementById('calManageEditColorBar'));
        var v = parseInt(((event.y - cb.y)/_colorBarHeight) * 100);
        return HsvToRgb(event.target.getAttribute("hue"), 100, 100 - v);
    }
    
    this.colorBarOver = function(){
        if (!event.target.getAttribute("hue")) return;
        var s = this.calculateHSVfromColorBarPosition();
        document.getElementById('calManageEditColorSwatch').style.backgroundColor = "#" + rgbToHex(s.red, s.green, s.blue);
    }
    
    this.colorBarClick = function(){
        if (!event.target.getAttribute("hue")) return;
        var s = this.calculateHSVfromColorBarPosition();       
        _currentCal.setThemeColor("#" + rgbToHex(s.red, s.green, s.blue));
        calChanged();
        dobedoPlug.postNotification("calendarList");
        this.loadSheet(_currentCal);
    }
    
    this.colorMouseDown = function(){
        if (!_currentCal.isNative()){
            event.preventDefault();
            event.stopPropagation();
            return;
        }
    }
    
    this.visibleClicked = function(){
        if (_currentCal.isAll()){
            _visibleAlert.showAlert("You can not change the visiblity of the All group");
            return;
        }
        _currentCal.setVisible(!_currentCal.isVisible());
        this.loadSheet(_currentCal);
        dobedoPlug.postNotification("calendarList");
    }
    
    this.colorChanged = function(){
        var s = document.getElementById('calManageEditColorSelect');
        if (s.options[s.selectedIndex].value == "") return;
        
        ////
        if ((s.options[s.selectedIndex].value) == "colorbar"){
            document.getElementById('calManageEditColorBar').style.visibility = "visible";
            document.getElementById('calManageEditHexValueBox').style.visibility = "hidden";
        }else if ((s.options[s.selectedIndex].value) == "hexvalue"){
            document.getElementById('calManageEditHexValueBox').style.visibility = "visible";
            document.getElementById('calManageEditColorBar').style.visibility = "hidden";
            document.getElementById('calManageEditHexInput').value = _currentCal.getThemeColor();
            document.getElementById('calManageEditHexInput').focus();
        }else{
            _currentCal.setThemeColor(s.options[s.selectedIndex].value);
            calChanged();
            dobedoPlug.postNotification("calendarList");
            this.loadSheet(_currentCal);
        }
        ////
    }
    
    this.setCalendarColor = function(newHexColor){
        if (!newHexColor) return;
        _currentCal.setThemeColor(newHexColor);
        calChanged();
        dobedoPlug.postNotification("calendarList");
        this.loadSheet(_currentCal);
    }
    
    this.formatCount = function(rc){
        if (isNaN(rc) || rc.length == 0) return "N/A";
        return rc + " task" + ((rc == 1) ? "" : "s");
    }
    
    this.showSheet = function(){
        this.show(); 
    }
    
    this.sheetClicked = function(){
    }
    
    this.dismissed = function(){
        if (_titleDirty) _currentCal.setTitle(document.getElementById('calManageEditNameInput').value);
        if (_callback) _callback();
        this.hideSheet();
    }
    
    
}

calEditSheet.prototype = new BHSheet();


/////////////////////////////////////////////////////////////////////////////////////


function calNewSheet(){
    var _calName = null;
    var _calType = null;
    var _cancelButton = null;
    var _saveButton = null;
    var _onSaveCallback = null;
    
    this.init = function(name, savecallback){
        this.baseInit(name);
        document.getElementById("sheetCover" + name).style.zIndex = 9501;
        var idiv = document.createElement("div");
        this._sheetDiv.appendChild(idiv);
        var ihtml = "<div class='calManageNewSheet'><div id='calManageNewContainer'><div class='calManageNewRow'><span class='calManageNewLabel'>Name:</span><span class='calManageNewField'><input type='text' id='calManageNewName'></span></div>";
        ihtml += "<div class='calManageNewRow'><span class='calManageNewLabel'>Type:</span><span class='calManageNewField'>DoBeDo List</span></div></div>";
        ihtml += "<div id='calManageNewCancel'></div><div id='calManageNewSave'></div>";
        ihtml += "</div>";
        
        idiv.innerHTML = ihtml;  
        
        _calName = idiv.getElementsByTagName('input')(0);
             
        _cancelButton = abutton(document.getElementById('calManageNewCancel'), "Cancel", createMethodReference(this, "sheetClicked"));
        
        _saveButton = abutton(document.getElementById('calManageNewSave'), "Save", createMethodReference(this, "saveClicked"));  
        
        this._defaultResponder = _calName;
        
        _onSaveCallback = savecallback;
    }
    
    this.cleanSheet = function(){
        _calName.value = "";
    }
    
    this.showSheet = function(){
        this.cleanSheet();
        this.show(); 
        _calName.focus();
    }
    
    this.sheetClicked = function(){
        this.hideSheet();
    }
    
    this.saveClicked = function(){
        if (_calName.value.length < 2) {
            this._defaultResponder.focus();
            return;
        }
        
        var ret = dobedoPlug.createNewDoBeDoList(_calName.value);
        
        this.sheetClicked();
        _onSaveCallback();
    }
    
}

calNewSheet.prototype = new BHSheet();


/////////////////////////////////////////////////////////////////////////////////////



function groupNewSheet(){
    var _dgc = null;
    var _dgLeft = null;
    var _dgRight = null;
    var _groupName = null;
    var _cancelButton = null;
    var _saveButton = null;
    var _onSaveCallback = null;
    var _groupInEdit = null;
    var _pickedCalendars = new Array();
    
    this.init = function(name, savecallback){
        this.baseInit(name);
        var idiv = document.createElement("div");
        this._sheetDiv.appendChild(idiv);
        var ihtml = "<div class='groupManageNewSheet'><div class='groupNewLabels' id='groupNewNameLabel'>Name:</div><input type='text' id='groupNewNameInput'>";
        ihtml += "<div id='newGroupInstructions'>Drag calendars from the left box to the right box</div>";
        ihtml += "<div class='groupNewNodeLists' id='groupNewExistingCals'></div><div class='groupNewNodeLists' id='groupNewPickedCals'></div>";
        ihtml += "<div id='groupNewCancelButton'></div><div id='groupNewSaveButton'></div>";
        ihtml += "</div>";
        idiv.innerHTML = ihtml;
        
        _groupName = document.getElementById('groupNewNameInput');
        
        _dgc = new BHDragableController();
        _dgc.setLandingCallback(createMethodReference(this, "calDropped"));
        
        _dgLeft = new BHDragableContainer(document.getElementById("groupNewExistingCals"),_dgc);
        _dgRight = new BHDragableContainer(document.getElementById("groupNewPickedCals"),_dgc);
        
        _cancelButton = abutton(document.getElementById('groupNewCancelButton'), "Cancel", createMethodReference(this, "cancelClicked"));
        
        _saveButton = abutton(document.getElementById('groupNewSaveButton'), "Save", createMethodReference(this, "saveClicked")); 
        
        this._defaultResponder = _groupName;
        _onSaveCallback = savecallback;
    }
    
    this.loadExistingGroup = function(g){
        
        _groupName.value = g.getTitle();
        
        var sa = g.getSourceKey().split(",");
        for(var i = 0; i < sa.length;i++){
            var c = calNodeFromSourceKey(sa[i]);
            if (!c) continue;
            _pickedCalendars.push(c.getNodeKey());
        }
        
        this.refreshPickedList();
    }
    
    this.populateNodeList = function(){
        var ihtml = "";
        
        for(var i = 0; i < gNodes.length; i++){
            if (gNodes[i].isGroup() || !gNodes[i].isVisible()) continue;
            ihtml += "<li id='glx" + gNodes[i].getNodeKey() + "' class='groupNewCalListItem'>" + gNodes[i].getTitle().substring(0,20) + "</li>";
        }
        document.getElementById("groupNewExistingCals").innerHTML = ihtml;
        
        _dgLeft.huntForDragons();
    }
    
    this.calDropped = function(){
        if (_dgc._takeoff._container.id == "groupNewExistingCals" && _dgc._landing._container.id == "groupNewPickedCals"){
            if (_pickedCalendars.contains(_dgc._inDrag.id.substring(3))) return;
            if (_dgc._inDrag.id.substring(3)) _pickedCalendars.push(_dgc._inDrag.id.substring(3));
        }
        
        if (_dgc._takeoff._container.id == "groupNewPickedCals" && _dgc._landing._container.id == "groupNewExistingCals"){
            _pickedCalendars.remove(_dgc._inDrag.id.substring(3));
        }
        
        this.refreshPickedList();
    }
    
    this.refreshPickedList = function(){
        document.getElementById("groupNewPickedCals").innerHTML = "";
        for(i = 0; i < _pickedCalendars.length; i++){
            var gn = nodeFromNodeID(_pickedCalendars[i]);
            document.getElementById("groupNewPickedCals").innerHTML += "<li class='groupNewCalListItem' id='glp" + gn.getNodeKey() + "'>" + gn.getTitle().substring(0,20) + "</li>";
        }
        
        _dgRight.huntForDragons();
    }
    
    this.cleanSheet = function(){
        _groupName.value = "";
        _pickedCalendars.clear();
        document.getElementById("groupNewPickedCals").innerHTML = "";
        this.populateNodeList();
        
        this._defaultResponder.focus();
    }
    
    this.showSheet = function(gnode){
        _groupInEdit = gnode;
        this.cleanSheet();
        if (_groupInEdit) this.loadExistingGroup(_groupInEdit);
        this.show(); 
        _groupName.blur();
        setTimeout(cmr(this,"setMainFocus"), 200);
    }
    
    this.setMainFocus = function(){
        _groupName.focus();
    }
    
    this.sheetClicked = function(){
       this._defaultResponder.focus();
    }
    
    this.cancelClicked = function(){
        this.hideSheet();
    }
    
    this.saveClicked = function(){
        if (_groupName.value.length < 1 || _pickedCalendars.length == 0){
            this._defaultResponder.focus();
            return;
        }
        
        var gn = (_groupInEdit) ? _groupInEdit.getNodeKey() : "null"
         
        var nodels = "<groupid>" + gn + "</groupid><groupname>" + _groupName.value + "</groupname><calcount>" + _pickedCalendars.length + "</calcount><cals>";
        
        for(var i = 0; i < _pickedCalendars.length; i++){
            if (i > 0) nodels += ",";
            nodels += nodeFromNodeID(_pickedCalendars[i]).getSourceKey();
        }
        
        nodels += "</cals>";
        
        dobedoPlug.createNewGroup(nodels);
        
        this.hideSheet();
        
        if (_onSaveCallback) _onSaveCallback();
    }
    
}

groupNewSheet.prototype = new BHSheet();


/////////////////////////////////////////////////////////////////////////////////////


function calListSheet(){

    var _calGroupMode = "cal";
    var _selectedCalendar = null;
    var _calAlert = null;
    var _calDeleteConfirm = null;
    var _calEditSheet = null;
    var _calNewSheet = null;
    var _groupNewSheet = null;
    var _calNewButton = null;
    var _calDeleteButton = null;
    var _calCloseButton = null;
    var _lastClickTime = new Date();
    
    this.init = function(name){
        this.baseInit(name);
        
        var idiv = document.createElement("div");
        this._sheetDiv.appendChild(idiv);
        var ihtml = "<div class='calListSheet'><div id='calendarListing'></div>";
        ihtml += "<div id='calListNewButton'></div><div id='calListDeleteButton'></div><div id='calListCloseButton'></div></div>";
        idiv.innerHTML = ihtml;
        
        this.refreshCalendarListing();
        
        _calEditSheet = new calEditSheet(); _calEditSheet.init("calmanageedit", createMethodReference(this, "refreshCalendarListing")); _calEditSheet.setRect(32,56,287,260);
        
        _calNewSheet = new calNewSheet(); _calNewSheet.init("calmanagenew",createMethodReference(this, "newCalCreated")); _calNewSheet.setRect(50,56,240,95);
        
        _groupNewSheet = new groupNewSheet(); _groupNewSheet.init("groupmanagenew",createMethodReference(this, "fullFreshy")); _groupNewSheet.setRect(32,56,287,260);
        
        _calAlert = new BHAlertDialog(); _calAlert.init("calmanagealert", {top:50,left:25,height:272,width:302}); _calAlert.setRect(80,120,190,90);
        
        _calDeleteConfirm = new BHConfirmationDialog(); _calDeleteConfirm.init("calmanagedeleteconfirm", {top:50,left:25,height:272,width:302},createMethodReference(this, "deleteNode")); 
        _calDeleteConfirm.setRect(80,120,190,90);
        
        _calNewButton = new AppleButton(document.getElementById('calListNewButton'), '+', 18, 'images/abutton_01.png', 'images/abuttonDown_01.png', 8, 'images/abutton_02.png', 'images/abuttonDown_02.png', 'images/abutton_03.png', 'images/abuttonDown_03.png', 8, createMethodReference(this, "newButtonClicked")); 
        
        _calDeleteButton = new AppleButton(document.getElementById('calListDeleteButton'), '-', 18, 'images/abutton_01.png', 'images/abuttonDown_01.png', 8, 'images/abutton_02.png', 'images/abuttonDown_02.png', 'images/abutton_03.png', 'images/abuttonDown_03.png', 8, createMethodReference(this, "deleteButtonClicked")); 
        
        _calCloseButton = new AppleButton(document.getElementById('calListCloseButton'), 'Close', 18, 'images/abutton_01.png', 'images/abuttonDown_01.png', 8, 'images/abutton_02.png', 'images/abuttonDown_02.png', 'images/abutton_03.png', 'images/abuttonDown_03.png', 8, createMethodReference(this, "closeClicked"));
    }
    
    this.refreshCalendarListing = function(){
        var ihtml = "";
        _selectedCalendar = null;
        
            for(var i = 0; i < gNodes.length; i++){
                if (gNodes[i].isGroup() && _calGroupMode == "cal") continue;
                if (!gNodes[i].isGroup() && _calGroupMode == "group") continue;
                ihtml += "<div id='clx" + gNodes[i].getNodeKey() + "'>" + gNodes[i].getTitle() + "</div>";
            }
                
        document.getElementById('calendarListing').innerHTML = ihtml;
        
            for(var i = 0; i < gNodes.length; i++){
                var x = document.getElementById("clx" + gNodes[i].getNodeKey()); 
                if (x) {
                    x.addEventListener("click", createMethodReference(this, "rowSelected"), false);
                    x.addEventListener("dblclick", createMethodReference(this, "rowdblClicked"), false);
                }
            }
    }
    
    
    this.rowSelected = function(){
        
        _selectedCalendar = nodeFromNodeID(event.target.id.substring(3, event.target.id.length));

        indicateSelectedElement(document.getElementById("calendarListing"), event.target.id);
    }
    
    this.rowdblClicked = function(){
        if (_calGroupMode == "group" && _selectedCalendar.isGroup() && !_selectedCalendar.isAll()){
            _groupNewSheet.showSheet(_selectedCalendar);
        }else{
            _calEditSheet.loadSheet(_selectedCalendar);
            _calEditSheet.showSheet();
        }
    }
    
    this.newButtonClicked = function(){
        if (_calGroupMode == "group"){
            _groupNewSheet.showSheet(null);
        }else{
            _calNewSheet.showSheet();
        }
    }
    
    this.deleteButtonClicked = function(){
        if (!_selectedCalendar) return;
        if (_selectedCalendar.isAll()){_calAlert.showAlert("The All group can not be deleted"); return;}
        if (!_selectedCalendar.isNative() && !_selectedCalendar.isGroup()){_calAlert.showAlert("Sorry, you can not delete " + _selectedCalendar.getTitle() + "."); return;}
        _calDeleteConfirm.showConfirm("Delete " + _selectedCalendar.getTitle().substring(0, 46) + "?");
    }
    
    this.deleteNode = function(){
        
        if (!dobedoPlug.deleteNode(_selectedCalendar.getNodeKey())) return;
        this.fullFreshy();        
    }
    
    this.newCalCreated = function(){
        this.fullFreshy();
    }
    
    this.showSheet = function(cmode){
        if (cmode) _calGroupMode = cmode;
        relistCalendars();
        this.refreshCalendarListing();
        this.show(); 
    }
    
    this.closeClicked = function(){
        _calEditSheet.hideSheet();
        _calNewSheet.hideSheet();
        relistCalendars();
        resetManageSelection();
        this.hideSheet();    
    }
    
    this.sheetClicked = function(){

    }
    
    this.fullFreshy = function(){
        relistCalendars(); calChanged();
        this.refreshCalendarListing();
        dobedoPlug.postNotification("calendarList");        
    }
    
}

calListSheet.prototype = new BHSheet();




/////////////////////////////////////////////////////////////////////////////////////


function clusterListSheet(){
    
    var _selectedCluster = null;
    
    this.init = function(name){
        this.baseInit(name);
        
        var idiv = document.createElement("div");
        this._sheetDiv.appendChild(idiv);
        var ihtml = "<div class='clusterListSheet' style='position:relative;'><div id='clusterListing'></div><div id='clusterListCloseButton' class='abuttons'></div></div>";
        idiv.innerHTML = ihtml;
        
    }
    
    this.refreshClusterList = function(){
        var html = "";
        var c; 
        
        var x = dobedoPlug.clusterList();
        
        var clusterCount = parseInt(gtg(x, "clustercount"));
        
        if (clusterCount == 0){
            document.getElementById('clusterListing').innerHTML = "<div id='clusterListEmptyHelp'>This box lists your favorites. <br>It is currently empty.<br> Flip the widget over to create new favorites.</div>";
            return;
        }
        
        for (var i = 0; i < clusterCount; i++){
            c = gtg(x, "cluster" + i);
            html += "<div id='clusterSheetListID" + gtg(c,"clusterid") + "'>" + gtg(c, "clustername") + "</div>";
        }
        
        document.getElementById('clusterListing').innerHTML = html;
        
        for(i = 0; i < clusterCount; i++){
            c = gtg(x, "cluster" + i);
            document.getElementById("clusterSheetListID" + gtg(c,"clusterid")).addEventListener("click", createMethodReference(this, "clusterItemSelected"), true);
            document.getElementById("clusterSheetListID" + gtg(c,"clusterid")).addEventListener("dblclick", createMethodReference(this, "clusterItemDblClicked"), true);
        }
    }
    
    this.clusterItemSelected = function(){
        _selectedCluster = event.target.id.substring(18, event.target.id.length);
        indicateSelectedElement(document.getElementById("clusterListing"), event.target.id);
    }
        
    this.clusterItemDblClicked = function(){
        if (!_selectedCluster) return;
        var x = dobedoPlug.clusterList();
        for (var i = 0; i < parseInt(gtg(x, "clustercount")); i++){
            c = gtg(x, "cluster" + i);
            if (gtg(c,"clusterid") == _selectedCluster){
                this.executeCluster(gtg(c, "tasks"));
                break;
            }
        }
        updateToDoData();
        this.closeSheet();   
    }
    
    this.executeCluster = function(tagCluster){
        for (var i = 0; i < parseInt(gtg(tagCluster, "taskcount")); i++){
            var t = gtg(c, "task" + i);
            dobedoPlug.addNewToDo(nodeFromNodeID(gtg(t,"taskcalendar")).getSourceKey(), gtg(t, "tasktitle"), true);
        }
    }
    
    this.showSheet = function(cmode){
        addKeyListener("clusterListKey", createMethodReference(this, "keyDownHandler"));
        this.refreshClusterList();
        this.show(); 
    }
    
    this.coverClicked = function(){
        this.closeSheet();    
    }
    
    this.closeSheet = function(){
        removeKeyListener("clusterListKey", createMethodReference(this, "keyDownHandler"));
        this.hideSheet();
    }
    
    this.keyDownHandler = function(){
        switch(event.keyCode){
            case 27:
                this.closeSheet();
                break;
        }
        event.hijacked = true;
    } 
    
}

clusterListSheet.prototype = new BHSheet();




/////////////////////////////////////////////////////////////////////////////////////


function clusterEditSheet(){
    var _clusterNewSheet = null;
    var _selectedCluster = null;
    var _clusterList = null;
    var _clusterDeleteConfirm = null;
    
    this.init = function(name){
        this.baseInit(name);
        
        var idiv = document.createElement("div");
        this._sheetDiv.appendChild(idiv);
        var ihtml = "<div class='clusterEditSheet'><div id='clusterEditListing'></div>";
        ihtml += "<div id='clusterEditListNewButton' class='abuttons'></div><div id='clusterEditListDeleteButton' class='abuttons'></div><div id='clusterEditListCloseButton' class='abuttons'></div></div>";

        idiv.innerHTML = ihtml;
        
        abutton(document.getElementById('clusterEditListNewButton'), "+", createMethodReference(this, "newClicked"));
        abutton(document.getElementById('clusterEditListDeleteButton'), "-", createMethodReference(this, "deleteClicked"));
        abutton(document.getElementById('clusterEditListCloseButton'), "Close", createMethodReference(this, "closeClicked"));
        
        _clusterNewSheet = new clusterNewSheet(); _clusterNewSheet.init("clusternew", createMethodReference(this, "refreshClusterList")); _clusterNewSheet.setRect(25,50,300,270);
        
        _clusterDeleteConfirm = new BHConfirmationDialog(); _clusterDeleteConfirm.init("clusterdeleteconfirm", {top:50,left:25,height:272,width:302},createMethodReference(this, "deleteCluster")); _clusterDeleteConfirm.setRect(80,120,190,90);
    }
    
    this.refreshClusterList = function(){
        var html = "";
        var c; 
        
        var x = dobedoPlug.clusterList();

        for (var i = 0; i < parseInt(gtg(x, "clustercount")); i++){
            c = gtg(x, "cluster" + i);
            html += "<div id='clusterEditSheetListID" + gtg(c,"clusterid") + "' >" + gtg(c, "clustername") + "</div>";
        }
        
        document.getElementById('clusterEditListing').innerHTML = html;
        
        for(i = 0; i < parseInt(gtg(x, "clustercount")); i++){
            c = gtg(x, "cluster" + i);
            document.getElementById("clusterEditSheetListID" + gtg(c,"clusterid")).addEventListener("click", createMethodReference(this, "clusterItemSelected"), true);
            document.getElementById("clusterEditSheetListID" + gtg(c,"clusterid")).addEventListener("dblclick", createMethodReference(this, "clusterItemDblClicked"), true);
        }
        
        _clusterList = x;
    }
    
    this.clusterItemSelected = function(){
        _selectedCluster = event.target.id.substring(22, event.target.id.length);
        indicateSelectedElement(document.getElementById("clusterEditListing"), event.target.id);
    }
    
    this.clusterItemDblClicked = function(){
        for(var i = 0; i < gtg(_clusterList, "clustercount"); i++){
            var c = gtg(_clusterList, "cluster" + i);
            if (gtg(c, "clusterid") == _selectedCluster){
                _clusterNewSheet.showSheet(c);
                return;
            }
        }
    }
    
    this.newClicked = function(){
        _clusterNewSheet.showSheet();
    }
    
    this.deleteCluster = function(){
        dobedoPlug.removeCluster(_selectedCluster);
        _selectedCluster = null;
        this.refreshClusterList();    
    }
    
    this.deleteClicked = function(){
        if (!_selectedCluster) return;
        _clusterDeleteConfirm.showConfirm("Delete favorite?");
    }
    
    this.showSheet = function(cmode){
        this.refreshClusterList();
        this.show(); 
    }
    
    this.closeClicked = function(){
        resetManageSelection();
        this.hideSheet();
    }
    
    this.sheetClicked = function(){}
    
}

clusterEditSheet.prototype = new BHSheet();




/////////////////////////////////////////////////////////////////////////////////////

function clusterDef(id, name){
    this.clusterID = id;
    this.clustername = name;
    this.tasks = [];
}

function clusterItem(id, task, calNode){
    this.clusterID = id;
    this.task = task;
    this.calNode = calNode;
}


function clusterNewSheet(){
    
    var _clusterName = null;
    var _clusterTask = null;
    var _clusterItems = new Array();
    var _selectedClusterItem = null;
    var _clusterCalendar = null;
    var _clusterEdit = null;
    var _saveCallBack = null;
    
    this.init = function(name, scb){
        this.baseInit(name);
        
        var idiv = document.createElement("div");
        this._sheetDiv.appendChild(idiv);

        var ihtml = "<div class='clusterNewSheet'><div class='clusterNewLabels' id='clusterNameLabel'>Favorite:</div><input type='text' id='clusterNameInput'>";
        ihtml += "<div id='clusterNewShadeBox'></div>";
        ihtml += "<div class='clusterNewLabels' id='clusterCalendarLabel'>Calendar:</div><select id='clusterNewCalendarSelect'></select>";
        ihtml += "<div class='clusterNewLabels' id='clusterTaskLabel'>Task:</div><input type='text' id='clusterTaskInput'><div id='clusterNewAddButton' class='abuttons'></div>";
        ihtml += "<div id='clusterNewAddList'></div>";
        ihtml += "<div id='clusterNewCancelButton' class='abuttons'></div><div id='clusterNewSaveButton' class='abuttons'></div>";
        ihtml += "</div>";
        idiv.innerHTML = ihtml;
        
        _clusterName = document.getElementById('clusterNameInput');
        _clusterTask = document.getElementById('clusterTaskInput');
        _clusterCalendar = document.getElementById('clusterNewCalendarSelect');
        
        abutton(document.getElementById('clusterNewCancelButton'), "Cancel", createMethodReference(this, "cancelClicked"));
        abutton(document.getElementById('clusterNewSaveButton'), "Save", createMethodReference(this, "saveClicked")); 
        abutton(document.getElementById('clusterNewAddButton'), "+", createMethodReference(this, "addClicked")); 
        
        document.getElementById('clusterTaskInput').addEventListener("focus", createMethodReference(this, "clusterInputFocus"), false);
        
        this._defaultResponder = _clusterName;
        
        _saveCallBack = scb;  
    }
    
    this.cleanSheet = function(){
        _clusterName.value = "";
        _clusterTask.value = "";
        _clusterItems.clear();
        this.loadCalendarsIntoSelect();
        this.refreshClusterList();
    }
    
    this.loadCalendarsIntoSelect = function(){
        _clusterCalendar.innerHTML = "";
        var x = document.getElementById('clusterNewCalendarSelect');
        for(var i = 0; i < gNodes.length; i++){
            if (gNodes[i].isGroup() || !gNodes[i].isVisible()) continue;
            addOptionToSelect(gNodes[i].getTitle(), gNodes[i].getNodeKey(), (gNodes[i] == currentCal()) ? true : false, _clusterCalendar);
        }
        
    }
    
    this.refreshClusterList = function(){
        var t = "";
        
        for(var i = 0 ; i < _clusterItems.length; i++){
            t += "<div id='" + _clusterItems[i].clusterID + "'>" + _clusterItems[i].task + "</div>";
        }
        
        document.getElementById('clusterNewAddList').innerHTML = t;
        
        for(var i = 0; i < _clusterItems.length; i++){
            document.getElementById(_clusterItems[i].clusterID).addEventListener("click", createMethodReference(this, "clusterItemSelected"), true);
        }
        
    }
    
    this.clusterItemSelected = function(){
        _selectedClusterItem = event.target.id;
        indicateSelectedElement(document.getElementById('clusterNewAddList'), _selectedClusterItem);   
    }
    
    this.addClicked = function(){
        if (_clusterTask.value.length == 0){_clusterTask.focus();return;}
        
        _clusterItems.push(new clusterItem(createGuid(), _clusterTask.value, _clusterCalendar.options[_clusterCalendar.selectedIndex].value));
        this.refreshClusterList();
        if (_selectedClusterItem)indicateSelectedElement(document.getElementById('clusterNewAddList'), _selectedClusterItem); 
        _clusterTask.value = "";
        _clusterTask.focus();
    }
    
    this.initClusterEdit = function(c){
        _clusterEdit = new clusterDef(gtg(c, "clusterid"), gtg(c, "clustername"));
        for(var i = 0; i < gtg(c, "taskcount"); i++){
            var n = gtg(c, "task" + i);
            var t = new clusterItem(gtg(n, "taskid"), gtg(n, "tasktitle"), gtg(n, "taskcalendar"));
            _clusterEdit.tasks.push(t);
        }
        
        _clusterName.value = _clusterEdit.clustername;
        _clusterItems = _clusterEdit.tasks;
        this.refreshClusterList();
         
    }
    
    this.showSheet = function(clusterEdit){
        addKeyListener("clusterNewKey", createMethodReference(this, "keyDownHandler"));
        this.cleanSheet();
            if (clusterEdit){
                this.initClusterEdit(clusterEdit);
            }else{
                _clusterEdit = null;
            }
        this.show(); 
        this._defaultResponder.blur();
        setTimeout(cmr(this,"setMainFocus"), 200);
    }
    
    this.setMainFocus = function(){
        this._defaultResponder.focus();
    }
    
    this.saveClicked = function(){
        if (!_clusterName.value) {_clusterName.focus(); return;}
        if (_clusterItems.length == 0){_clusterTask.focus();return;}

        var cid  = (_clusterEdit) ? _clusterEdit.clusterID : createGuid();

        var s = "<cluster><clusterid>" + cid + "</clusterid><clustername>" + _clusterName.value + "</clustername><taskcount>" + _clusterItems.length + "</taskcount></cluster><tasks>";
        for(var i = 0; i < _clusterItems.length; i++){
            s += "<task" + i + "><taskid>" + _clusterItems[i].clusterID + "</taskid><tasktitle>" + _clusterItems[i].task + "</tasktitle><taskcalendar>" + _clusterItems[i].calNode + "</taskcalendar></task" + i + ">";
        }
        s += "</tasks>";
        
        dobedoPlug.saveCluster(s);
        
        this.closeSheet();
        
        if (_saveCallBack) _saveCallBack();
    }
    
    this.cancelClicked = function(){
        this.closeSheet();
    }
    
    this.sheetClicked = function(){}
    
    this.deleteKeyed = function(){
        if (!_selectedClusterItem) return;
        for(var i = 0; i < _clusterItems.length; i++){
            if (_clusterItems[i].clusterID == _selectedClusterItem) _clusterItems.splice(i, 1);
        }
        this.refreshClusterList();
        _selectedClusterItem = null;
    }
    
    this.closeSheet = function(){
        removeKeyListener("clusterNewKey", createMethodReference(this, "keyDownHandler"));
        this.hideSheet();
    }
    
    this.keyDownHandler = function(){
        switch(event.keyCode){
            case 8:
                this.deleteKeyed();
                event.stopPropagation();
                break;
            case 37:
                event.stopPropagation();
                break;
            case 38:
                event.stopPropagation();
                break;
            case 46:
                this.deleteKeyed();
                event.preventDefault();
                event.stopPropagation();
                break;
        }
        event.hijacked = true;
    }
    
    this.clusterInputFocus = function(){
        _selectedClusterItem = null;
        this.refreshClusterList();
    }
    
}

clusterNewSheet.prototype = new BHSheet();





/////////////////////////////////////////////////////////////////////////////////////

function schedSort(a,b){
    return a.task.strCaseCmp(b.task);
}

function scheduleEditSheet(){

    var _selectedSchedule = null;
    var _scheduleNewSheet = null;
    var _scheduleDeleteConfirm = null;
    var _sa = [];
    
    this.init = function(name){
        this.baseInit(name);
        
        var idiv = document.createElement("div");
        this._sheetDiv.appendChild(idiv);
        var ihtml = "<div class='scheduleEditSheet'><div id='scheduleEditListing'></div>";
        ihtml += "<div id='scheduleEditListNewButton' class='abuttons'></div><div id='scheduleEditListDeleteButton' class='abuttons'></div><div id='scheduleEditListCloseButton' class='abuttons'></div></div>";

        idiv.innerHTML = ihtml;
        
        abutton(document.getElementById('scheduleEditListNewButton'), "+", createMethodReference(this, "newClicked"));
        abutton(document.getElementById('scheduleEditListDeleteButton'), "-", createMethodReference(this, "deleteClicked"));
        abutton(document.getElementById('scheduleEditListCloseButton'), "Close", createMethodReference(this, "closeClicked"));
        
        _scheduleNewSheet = new scheduleNewSheet(); _scheduleNewSheet.init("schedulenew", createMethodReference(this, "refreshScheduleList")); _scheduleNewSheet.setRect(25,50,300,270);
        _scheduleDeleteConfirm = new BHConfirmationDialog(); _scheduleDeleteConfirm.init("scheduledeleteconfirm", {top:50,left:25,height:272,width:302},createMethodReference(this, "deleteSchedule")); _scheduleDeleteConfirm.setRect(80,120,190,90);
    }
    
    this.refreshScheduleList = function(){
        var html = ""; var c; 
        
        var x = dobedoPlug.scheduleList();
        
        _sa.clear();
        
        for (var i = 0; i < parseInt(gtg(x, "schedulecount")); i++){
            c = gtg(x, "schedule" + i);
            var ns = {};
            ns.schid = gtg(c,"scheduleid"); ns.task = gtg(c, "task"); ns.taskcalendar = gtg(c, "taskcalendar");
            ns.active = gtg(c, "active"); ns.byday = gtg(c, "byday"); ns.duplicates = gtg(c, "duplicates");
            ns.interval = gtg(c, "interval"); ns.freq = gtg(c, "freq"); ns.lastrun = gtg(c, "lastrun");
            _sa.push(ns);
        }
        
        _sa.sort(schedSort);
        
        for(var i = 0; i < _sa.length; i++){
            html += "<div id='scheduleEditSheetListID" + _sa[i].schid + "'>" + _sa[i].task + "</div>";
        }
        
        document.getElementById('scheduleEditListing').innerHTML = html;
        
        for(i = 0; i < _sa.length; i++){
            c = gtg(x, "schedule" + i);
            document.getElementById("scheduleEditSheetListID" + gtg(c,"scheduleid")).addEventListener("click", createMethodReference(this, "scheduleItemSelected"), true);
            document.getElementById("scheduleEditSheetListID" + gtg(c,"scheduleid")).addEventListener("dblclick", createMethodReference(this, "scheduleItemDblClicked"), true);
        }
        
        _selectedSchedule = null;
    }
    
    this.getScheduleObject = function(scheduleID){
        for(var i = 0; i < _sa.length; i++){
            if (_sa[i].schid == scheduleID) return _sa[i];
        }
        return null;
    }
    
    this.scheduleItemSelected = function(){
        _selectedSchedule = event.target.id.substring(23);
        indicateSelectedElement(document.getElementById("scheduleEditListing"), event.target.id);
    }
    
    this.newClicked = function(){
        _scheduleNewSheet.showSheet();
    }
    
    this.deleteSchedule = function(){
        dobedoPlug.removeScheduleJob(_selectedSchedule);
        this.refreshScheduleList();    
    }
    
    this.deleteClicked = function(){
        if (!_selectedSchedule) return;
        _scheduleDeleteConfirm.showConfirm("Delete item?");
    }
    
    this.scheduleItemDblClicked = function(){
        var s = this.getScheduleObject(_selectedSchedule);
        if (!s) return;
        _scheduleNewSheet.showSheet(s);
    }
    
    this.showSheet = function(cmode){
        this.refreshScheduleList();
        this.show(); 
    }
    
    this.closeClicked = function(){
        resetManageSelection();
        this.hideSheet();
    }
    
    this.sheetClicked = function(){}
    
}

scheduleEditSheet.prototype = new BHSheet();


/////////////////////////////////////////////////////////////////////////////////////


function scheduleNewSheet(){

    var _scheduleTask = null;
    var _scheduleCalendar = null;
    var _scheduleRepeats = null;
    var _scheduleActive = null;
    var _scheduleDuplicates = null;
    var _scheduleInEdit = null;
    var _saveCallBack = null;
    
    this.init = function(name, scb){
        this.baseInit(name);
        
        var idiv = document.createElement("div");
        this._sheetDiv.appendChild(idiv);

        var ihtml = "<div class='scheduleNewSheet'><div class='scheduleNewLabels' id='scheduleTaskLabel'>Task:</div><input type='text' id='scheduleTaskInput'>";
        ihtml += "<div class='scheduleNewLabels' id='scheduleCalendarLabel'>Calendar:</div><select id='scheduleNewCalendarSelect'></select>";
        ihtml += "<div class='scheduleNewLabels' id='scheduleRepeatsLabel'>Repeats:</div><select id='scheduleNewRepeatSelect'><option value=1 id='DAILY'>Every Day</option><option value=0 id='WEEKLY'>Every Sunday</option><option value=1 id='WEEKLY' selected>Every Monday</option><option value=2 id='WEEKLY'>Every Tuesday</option><option value=3 id='WEEKLY'>Every Wednesday</option><option value=4 id='WEEKLY'>Every Thursday</option><option value=5 id='WEEKLY'>Every Friday</option><option value=6 id='WEEKLY'>Every Saturday</option><option value=1 id='MONTHLY'>1st day of the Month</option><option value=2 id='MONTHLY'>2nd day of the Month</option><option value=3 id='MONTHLY'>3rd day of the Month</option><option value=4 id='MONTHLY'>4th day of the Month</option><option value=5 id='MONTHLY'>5th day of the Month</option><option value=6 id='MONTHLY'>6th day of the Month</option><option value=7 id='MONTHLY'>7th day of the Month</option><option value=8 id='MONTHLY'>8th day of the Month</option><option value=9 id='MONTHLY'>9th day of the Month</option><option value=10 id='MONTHLY'>10th day of the Month</option><option value=11 id='MONTHLY'>11th day of the Month</option><option value=12 id='MONTHLY'>12th day of the Month</option><option value=13 id='MONTHLY'>13th day of the Month</option><option value=14 id='MONTHLY'>14th day of the Month</option><option value=15 id='MONTHLY'>15th day of the Month</option><option value=16 id='MONTHLY'>16th day of the Month</option><option value=17 id='MONTHLY'>17th day of the Month</option><option value=18 id='MONTHLY'>18th day of the Month</option><option value=19 id='MONTHLY'>19th day of the Month</option><option value=20 id='MONTHLY'>20th day of the Month</option><option value=21 id='MONTHLY'>21st day of the Month</option><option value=22 id='MONTHLY'>22nd day of the Month</option><option value=23 id='MONTHLY'>23rd day of the Month</option><option value=24 id='MONTHLY'>24th day of the Month</option><option value=25 id='MONTHLY'>25th day of the Month</option><option value=26 id='MONTHLY'>26th day of the Month</option><option value=27 id='MONTHLY'>27th day of the Month</option><option value=28 id='MONTHLY'>28th day of the Month</option><option value=29 id='MONTHLY'>29th day of the Month</option><option value=30 id='MONTHLY'>30th day of the Month</option><option value=31 id='MONTHLY'>31st day of the Month</option><option value=32 id='MONTHLY'>Last day of the Month</option></select>";
        ihtml += "<div class='scheduleNewLabels' id='scheduleActiveLabel'>Active:</div><select id='scheduleNewActiveSelect'><option value=1 selected>Yes</option><option value=0>No</option></select>";
        ihtml += "<div class='scheduleNewLabels' id='scheduleDuplicatesLabel'>Duplicates:</div><select id='scheduleNewDuplicatesSelect'><option value=1 selected>Yes, allow duplicates</option><option value=0>No Duplicates</option></select>";
        ihtml += "<div id='scheduleNewCancelButton' class='abuttons'></div><div id='scheduleNewSaveButton' class='abuttons'></div>";
        ihtml += "</div>";
        idiv.innerHTML = ihtml;
        
        _scheduleTask = document.getElementById('scheduleTaskInput');
        _scheduleCalendar = document.getElementById('scheduleNewCalendarSelect');
        _scheduleRepeats = document.getElementById('scheduleNewRepeatSelect');
        _scheduleActive = document.getElementById('scheduleNewActiveSelect');
        _scheduleDuplicates = document.getElementById('scheduleNewDuplicatesSelect');
        
        abutton(document.getElementById('scheduleNewCancelButton'), "Cancel", createMethodReference(this, "cancelClicked"));
        abutton(document.getElementById('scheduleNewSaveButton'), "Save", createMethodReference(this, "saveClicked")); 
        
        this._defaultResponder = _scheduleTask;
        
        _saveCallBack = scb;  
    }
    
    this.cleanSheet = function(){
        _scheduleTask.value = "";
        this.loadCalendarsIntoSelect();
    }
    
    this.loadScheduleForEdit = function(){
        _scheduleTask.value = _scheduleInEdit.task;
        this.loadCalendarsIntoSelect(_scheduleInEdit.taskcalendar);
        //repeats
        for(var i = 0; i < _scheduleRepeats.childNodes.length; i++){
            _scheduleRepeats.childNodes[i].selected = (_scheduleInEdit.freq == _scheduleRepeats.childNodes[i].id && _scheduleInEdit.byday == _scheduleRepeats.childNodes[i].value) ;
        }
        //active
        for(var i = 0; i < _scheduleActive.childNodes.length; i++){
            _scheduleActive.childNodes[i].selected = (_scheduleInEdit.active == _scheduleActive.childNodes[i].value) ;
        }
        //duplicates
        for(var i = 0; i < _scheduleDuplicates.childNodes.length; i++){
            _scheduleDuplicates.childNodes[i].selected = (_scheduleInEdit.duplicates == _scheduleDuplicates.childNodes[i].value) ;
        }      
    }
    
    this.loadCalendarsIntoSelect = function(selectedCalNode){
        _scheduleCalendar.innerHTML = "";
        var x = document.getElementById('scheduleNewCalendarSelect');
        for(var i = 0; i < gNodes.length; i++){
            if (gNodes[i].isGroup() || !gNodes[i].isVisible()) continue;
            if (selectedCalNode){
                addOptionToSelect(gNodes[i].getTitle(), gNodes[i].getNodeKey(), (gNodes[i].getNodeKey() == selectedCalNode) ? true : false, _scheduleCalendar);
            }else{
                addOptionToSelect(gNodes[i].getTitle(), gNodes[i].getNodeKey(), (gNodes[i] == currentCal()) ? true : false, _scheduleCalendar);
            }
        } 
    }
    
    this.showSheet = function(existingSchedule){
        _scheduleInEdit = existingSchedule;
        this.cleanSheet();
        if (_scheduleInEdit){
            this.loadScheduleForEdit();
        }
        this.show();
        this._defaultResponder.blur();
        setTimeout(cmr(this,"setMainFocus"), 200);
    }
    
    this.setMainFocus = function(){
        this._defaultResponder.focus();
    }
    
    this.saveClicked = function(){
        if (_scheduleTask.value.length == 0){
            this._defaultResponder.focus();
            return;
        }
        
        dobedoPlug.newScheduleJob((_scheduleInEdit) ? _scheduleInEdit.schid : "nil", _scheduleTask.value, _scheduleCalendar.options[_scheduleCalendar.selectedIndex].value,
                                    _scheduleActive.options[_scheduleActive.selectedIndex].value, _scheduleDuplicates.options[_scheduleDuplicates.selectedIndex].value,
                                    _scheduleRepeats.options[_scheduleRepeats.selectedIndex].id, _scheduleRepeats.options[_scheduleRepeats.selectedIndex].value, 1);
        this.hideSheet();  
        if (_saveCallBack) _saveCallBack();
    }
    
    this.cancelClicked = function(){
        this.hideSheet();
    }
    
    this.sheetClicked = function(){}
    
}

scheduleNewSheet.prototype = new BHSheet();


/////////////////////////////////////////////////////////////////////////////////////




