
Array.prototype.indexOf = function(x) {
  for (var i = 0; i < this.length; i++) {
    if (this[i] == x) return i;
  }
  return -1;
}

Array.prototype.contains = function(x) {return this.indexOf(x) >= 0;}

Array.prototype.clear = function(){this.splice(0, this.length);}

Array.prototype.remove = function(x){
    var i = this.indexOf(x);
    if (i == -1 ) return;
    this.splice(i,1);
}

Array.prototype.addNodes= function(x){
    for(var i = 0; i < x.length; i++){
        this.push(x[i]);
    }
}


/////

String.prototype.strCaseCmp = function(x){
    var ax = this.toLowerCase(); var bx = x.toLowerCase();
    if (ax == bx){
        return 0;
    }else if (ax < bx){
        return -1;
    }else{
        return 1;
    }
}

////

function getat(str, tag)
{
    var re = new RegExp("<" + tag + ">"); var p1 = re.exec(str);
        if (!p1) return "";
    
    var re2 = new RegExp("</" + tag + ">"); re2.lastIndex = p1.index; var p2 = re2.exec(str);
        if (!p2) return "";
        
    var x = p1.index + tag.length + 2;

    return str.slice(x, p2.index); 
}

function gtg(str,tag){return getat(str,tag);}

function tagDataDecode(str){
    str = str.replace(/&#38;/g, "&");
    str = str.replace(/&#60;/g, "<");
    str  = str.replace(/&#62;/g, ">");
    return str;
}

function addOptionToSelect(optionTitle, optionValue, optionSelected, parentSelect){
    var op = document.createElement("option");
    op.appendChild(document.createTextNode(optionTitle));
    op.value = optionValue;
    op.selected = optionSelected;
    parentSelect.appendChild(op);
    return op;
}

function abutton(button, buttonText, clickMethod){
    var ab =  new AppleButton(button, buttonText, 18, 'images/abutton_01.png', 'images/abuttonDown_01.png', 8, 'images/abutton_02.png', 'images/abuttonDown_02.png', 'images/abutton_03.png', 'images/abuttonDown_03.png', 8, clickMethod);
    return ab;
}


function addClass(element, namedClass){
    if (typeof(element) == "string") element = document.getElementById(element);
    if (!element) return false;
    
    if (hasClass(element, namedClass)){
        return false;
    }else{
        element.className += (element.className ? ' ' : '') + namedClass;
    }
    
    return true;
}

function removeClass(element, namedClass){
    if (typeof(element) == "string") element = document.getElementById(element);
    if (!element) return false;
    
    var exc = element['className'].split();
    var re = new RegExp('(?:^|\\s+)' + namedClass + '(?:\\s+|$)');
    var x = element['className'];
    element['className']=x.replace(re,' ');

    return true;
}

function hasClass(element, namedClass){
    var rex = new RegExp('(?:^|\\s+)' + namedClass + '(?:\\s+|$)');
    return rex.test(element['className']);
}

function testFunction(pf, hits)
{
    var r = 100;
    if (hits) r = hits;
    alert("Start run (" + r + ")");
    for(var i = 0; i < r; i++){
        pf();
    }
    alert("End");
}

function ddump(x){
    alert("\n\n//////////////////////////////****** Object:" + x + " ******////////////////////////////////\n");
    for (i in x){
        var a = x[i];
        if (a instanceof Function){
            alert(i + ": function");
        }else{
            alert(i + ":" + a);
        }
    }
    alert("\n//////////////////////////////*********************************////////////////////////////////\n");
}

function createGuid(){
    var d = new Date();
    return Math.floor(Math.random() * 10000) + "-" + d.getFullYear() + "-" + d.getMonth() + "-" + d.getDate() + "-" + d.getMonth() + "-" + d.getHours() + "-" + d.getMinutes() + "-" + d.getSeconds() + "-" + d.getMilliseconds() + "-" + Math.floor(Math.random() * 10000);
}

function createMethodReference(object, methodName) {
    return function () {
        object[methodName].apply(object, arguments);
    }
}

function cmr(object, methodName) {
    return createMethodReference(object, methodName);
}

function indicateSelectedElement(parentContainer, selectedElementID){
        for(var i = 0; i < parentContainer.childNodes.length; i++){
            var trx = parentContainer.childNodes[i];
            
            if(trx.id == selectedElementID){
                trx.style.backgroundColor = "#8CB1E0";
            }else{
                trx.style.backgroundColor = "#FEFEFE";
            }
        }
}

function highLightSelectedElement(parentContainer, selectedElementID, boldText){
        for(var i = 0; i < parentContainer.childNodes.length; i++){
            var trx = parentContainer.childNodes[i];
            
            if(trx.id == selectedElementID){
                trx.style.backgroundColor = "#8CB1E0";
                if (boldText) trx.style.fontWeight = "bold";
            }else{
                trx.style.backgroundColor = "#F3F3F3";
                if (boldText) trx.style.fontWeight = "normal";
            }
        }
}

function leopardOSX(){
    return (parseInt(gtg(dobedoPlug.pluginBuild(), "appkit")) >= 949);
}

function pluginOK(){
    gCurrentBuild = gtg(dobedoPlug.pluginBuild(), "plugin");
    return (gCurrentBuild != "");
}

function absolutePosition(pt){
    var r = {x:0,y:0};
        while(pt.offsetParent){
            r.x += pt.offsetLeft; r.y += pt.offsetTop;
            pt = pt.offsetParent;
        }
    return r;
}


/////


function decToHex(d){
    return (d < 16 ? '0' : '') + d.toString(16).toUpperCase();
}

function rgbToHex(r,g,b){
    return decToHex(r) + decToHex(g) + decToHex(b);
}

function HsvToRgb(h, s, v) {
    var r,g,b;
	h = h/360;s = s/100;v = v/100;
	
	if (s > 0){
	   if (h >= 1.0) h = 0;
	   h = 6 * h;
	   f = h - Math.floor(h);
	   x = Math.round(255*v*(1.0-s));
	   y = Math.round(255*v*(1.0-(s*f)));
	   z = Math.round(255*v*(1.0-(s*(1.0-f))));
	   v = Math.round(255*v);
	   
	   switch(Math.floor(h)){
	       case 0:r=v;g=z;b=x;break;
	       case 1:r=y;g=v;b=x;break;
	       case 2:r=x;g=v;b=z;break;
	       case 3:r=x;g=y;b=v;break;
	       case 4:r=z;g=x;b=v;break;
	       case 5:r=v;g=x;b=y;break;
	   }
	   
	   return ({red:r,green:g,blue:b});
    }else{
        v = Math.round(v*255);
        return ({red:v, green:v, blue:v});
    }
}





